tsrb2kr.Results_TriggerResults = function()
	-- check if everyone is done racing
	local playersdone, totalplayers = 0, 0

	for p in players.iterate
		-- get players ingame
		if not (p.spectator)
			totalplayers = $+1
		end
		
		-- prevent p.exiting from getting too low
		if (p.exiting and p.exiting < 8) then p.exiting = 8 end
		
		-- detect players who are "finished"
		if (p.exiting and p.exiting == 8)
		or (p.pflags & PF_TIMEOVER)
			-- make sure to not include spectators
			if not (p.spectator) then playersdone = $+1 end
		end
	end
	if not (totalplayers) then return end	-- lol what
	
	-- is everyone in a finished state?
	-- or stop the exitcountdown timer because god
	if (playersdone >= totalplayers or exitcountdown == 8) 
	and not (server.tsr_server.finishstate)
		-- set exit countdown
		K_SetExitCountdown(TICRATE*2 + 128 + TICRATE*8 + 1)
		
		-- now that teams are sorted, apply realtime to make up the rankinsgs
		server.tsr_server.finishstate = true	-- start handling finish
		server.tsr_server.finishtimer = 0
		server.tsr_server.finish = {}	-- init this table
		server.tsr_server.finishrankings = {}				-- and this one too
		server.tsr_server.finishteamscore = {}				-- and also this one, oh my god fuck off

		-- build finish table:
		for i = 1, #server.tsr_server.teams
			server.tsr_server.finish[i] = {}
			server.tsr_server.finishteamscore[i] = {}

			for j = 1, #server.tsr_server.teams[i]
				local p = server.tsr_server.teams[i][j]

				-- color the name with team prefix
				local c = {
					tsrb2kr.ColorToMap(tsrb2kr.ReturnTeamColor(1)),
					tsrb2kr.ColorToMap(tsrb2kr.ReturnTeamColor(2)),
					tsrb2kr.ColorToMap(tsrb2kr.ReturnTeamColor(3)),
					tsrb2kr.ColorToMap(tsrb2kr.ReturnTeamColor(4)),
					tsrb2kr.ColorToMap(tsrb2kr.ReturnTeamColor(5))
				}

				local t = {
					name = c[p.tsr.team]..p.name,
					skin = p.mo.skin,
					color = p.skincolor,
					rank = p.kartstuff[k_position],	-- save some stuff so players leaving don't impact rankings
					score = tsrb2kr.ReturnPoints(p),	-- how many points we got
					addedscore = 0,					-- used for display
					displayscore = 0,				-- used for visuals only
					team = p.tsr.team,				-- for name coloration
				}

				server.tsr_server.finish[i][j] = t
				server.tsr_server.finishrankings[#server.tsr_server.finishrankings+1] = t
				server.tsr_server.finishteamscore[i][#server.tsr_server.finishteamscore[i]+1] = t

				--print("Saved entry for team "..i.." player "..j)
			end
			-- sort score from lowest to highest for animation
			table.sort(server.tsr_server.finishteamscore[i], function(a, b) return a.score < b.score end)
		end

		-- ready a table of players by points for rankings
		table.sort(server.tsr_server.finishrankings, function(a, b) return a.rank < b.rank end)

		--print("Sorted rankings, entering results...")
		local sortedteams = server.tsr_server.sortedteams
		for i = 1, 5
			if not (sortedteams[i]) then continue end
			if not (sortedteams[i][1]) then continue end
			if not (server.tsr_server.teams[sortedteams[i][1]]) then continue end
			for k, v in ipairs(server.tsr_server.teams[sortedteams[i][1]])
				v.realtime = 69*i	-- a man can have their fun
			end
		end
		S_ChangeMusic("RACENT", true)
	end
end

tsrb2kr.Results_HandleFinish = function()
	if not (server.tsr_server.finishstate) then return end
	server.tsr_server.finishtimer = $+1

	if (server.tsr_server.finishtimer > TICRATE*2)
		-- start filling the bars
		-- start with lowest score. for as long as their bar isn't done, BREAK out of the loop.

		local playsound

		for i = 1, #server.tsr_server.finishteamscore
			for j = 1, #server.tsr_server.finishteamscore[i]
				local info = server.tsr_server.finishteamscore[i][j]
				if info.displayscore < (info.score + (info.addedscore or 0))	-- score not done counting
					--print(info.displayscore.."|"..(info.score + (info.addedscore or 0)))
					if server.tsr_server.finishtimer%2		-- don't count too fast
						info.displayscore = $+1
						-- don't earrape me please
						if not playsound
							S_StartSound(nil, sfx_menu1)
							playsound = true
						end

						-- give our points to next info. the reason we do this is purely for visual shit
						for k = j+1, j+2
							if server.tsr_server.finishteamscore[i][k]
								server.tsr_server.finishteamscore[i][k].displayscore = $+1
								server.tsr_server.finishteamscore[i][k].addedscore = $+1
							end
						end
					end
					break	-- break out, go to the next team
				end
			end
		end
	end
	-- given there's a max of 46 pts, we can safely assume that 128 tics is a safe time to wait before attributing grades

	if (server.tsr_server.finishtimer == TICRATE*2 + 128)
		-- sort team numbers by decressing rank
		server.tsr_server.finishteamrankings = {}
		for i = 1, #server.tsr_server.teams
			server.tsr_server.finishteamrankings[i] = i
		end
		table.sort(server.tsr_server.finishteamrankings, function(a, b) return tsrb2kr.ReturnFinishTeamScore(a) < tsrb2kr.ReturnFinishTeamScore(b) end)
		
		server.tsr_server.inttime = CV_FindVar("inttime").value	-- save this to reset later
		COM_BufInsertText(server, "inttime 0")	-- doesn't save
		-- we're good to go, finish the animation and then we can exit.
	elseif (server.tsr_server.finishtimer == TICRATE*2 + 128 + TICRATE*8)	-- eh that sounds good
		if (tsrb2kr.cv_tc.value)
			for p in players.iterate
				if (p.tsr.oldskincolor)
					tsrb2kr.SmartSetColor(p, false, p.tsr.oldskincolor)
					p.skincolor = p.tsr.oldskincolor

					p.tsr.oldskincolor = nil
				end
			end
		end
		-- we have exitcountdown now, I'm gonna try disable this
		G_ExitLevel()
	elseif (server.tsr_server.finishteamrankings)
		-- play rank sfx here to not mess with certain builds
		for i = 1, #server.tsr_server.teams
			if not server.tsr_server.teams[i][1] or not server.tsr_server.teams[i][1].valid
				continue
			end

			if (server.tsr_server.finishtimer > TICRATE*2 + 128)
				for j = 1, #server.tsr_server.finishteamrankings

					local req = TICRATE*2 + 128 + (j*17)
					if server.tsr_server.finishtimer >= req
					and server.tsr_server.finishteamrankings[j] == i

						local pos = 6-j
						-- if there's a tie, just grab the rank of the next team over;
						-- constantly check over and over so we can get multiple ties if need be
						local nextteam_i = 1
						local nextteam = server.tsr_server.finishteamrankings[j+nextteam_i]

						while (nextteam)
							if (tsrb2kr.ReturnFinishTeamScore(server.tsr_server.finishteamrankings[j]) == tsrb2kr.ReturnFinishTeamScore(nextteam))
								pos = 6-(j+nextteam_i)
							end
							-- search for the next team in line
							nextteam_i = $+1
							nextteam = server.tsr_server.finishteamrankings[j+nextteam_i]
						end

						if j == #server.tsr_server.finishteamrankings or pos == 1
							if server.tsr_server.finishtimer == req + 4
								S_StartSound(nil, sfx_rnk1st)
							end
						else
							if server.tsr_server.finishtimer == req + 4
								S_StartSound(nil, sfx_rnkp)
							end
						end
					end
				end
			end
		end
		
		-- play a victory sound from a random member of the winning team
		-- first let's find out when we can do it:
		
		local req = TICRATE*2 + 128 + (#server.tsr_server.finishteamrankings*17) + 20
		-- 20 tics after the "1" appears
		
		if (server.tsr_server.finishtimer < req) then return end	-- not time yet
		
		-- get the amount of teams that won (also store highest score for obvious reasons)
		local teams_won = 1
		local highest_score = tsrb2kr.ReturnFinishTeamScore(server.tsr_server.finishteamrankings[#server.tsr_server.finishteamrankings])
		for i = #server.tsr_server.finishteamrankings, 1, -1
			local team = server.tsr_server.finishteamrankings[i]
			-- we've already counted the winning team
			if (i == #server.tsr_server.finishteamrankings) then continue end
			if (tsrb2kr.ReturnFinishTeamScore(team) != highest_score) then continue end
			-- if we get here, then they definitely tied with 1st
			teams_won = $+1
		end
		
		for i = 0, (teams_won-1)
			local req = TICRATE*2 + 128 + (#server.tsr_server.finishteamrankings*17) + 20 + (18*i)
			if server.tsr_server.finishtimer ~= req then continue end	-- not time yet
			
			local team = server.tsr_server.finishteamscore[server.tsr_server.finishteamrankings[#server.tsr_server.finishteamrankings-i]]
			local info = team[P_RandomRange(1, #team)]
			local skin = info and info.skin or "sonic"
			
			if (CV_FindVar("kartvoices").value)
				S_StartSound(nil, skins[skin].soundsid[SKSKWIN])
			end
		end
	end
end

tsrb2kr.Framework_ResultHandler = function()
	tsrb2kr.Results_TriggerResults()
	tsrb2kr.Results_HandleFinish()
end