-- everything skimboost related
tsrb2kr.Skimboosts_SpawnIndicator = function(p)
	local mo = p.mo
	
	if not (tsrb2kr.PlayerNeedsSkimboost(p)) then return end
	if not (mo and mo.valid) then return end
	
	if not mo.tsr_skimbindicator or not mo.tsr_skimbindicator.valid
		mo.tsr_skimbindicator = P_SpawnMobj(mo.x, mo.y, mo.z, MT_TSR_SKIMBINDICATOR)
		mo.tsr_skimbindicator.target = mo
		mo.tsr_skimbindicator.color = tsrb2kr.ReturnTeamColor(p.tsr.team)
		mo.tsr_skimbindicator.flags2 = $|MF2_DONTDRAW
	end
end

tsrb2kr.Skimboosts_HelpTeammates = function(p)
	if (p.kartstuff[k_spinouttimer]) then return end	-- we cant give skimboosts while spun out
	local mo = p.mo
	
	for k, v in ipairs(server.tsr_server.teams[p.tsr.team])
		if (p == v) then continue end	-- we cant skimboost ourselves!
		if not (v.mo and v.mo.valid) then continue end	-- they need a valid mo
		if not (tsrb2kr.PlayerNeedsSkimboost(v)) then continue end	-- they don't even need a skimboost!
		
		if (R_PointToDist2(mo.x, mo.y, v.mo.x, v.mo.y) < (mapobjectscale)*256)
		and (R_PointToDist2(0, 0, mo.momx, mo.momy) > K_GetKartSpeed(p)/2)	-- we're fast as fuck boi
		and (abs(mo.z - v.mo.z) < mapobjectscale*2048)	-- dumb way to check for aprox height
			-- 192 scale units away from a slow teammate
			-- help them out!
			v.mo.tsr_skimboost = true
			v.mo.tsr_skimboostplayer = p
			v.mo.tsr_skimboostcd = TICRATE*6	-- cooldown
			mo.tsr_skimboostcd = TICRATE*6	-- cool me down as well

			local s = P_SpawnMobj(v.mo.x, v.mo.y, v.mo.z, MT_TSR_SKIMB)
			s.target = v.mo
			s.state = S_THOK
			s.sprite = SPR_SKMB
			s.scale = 3*mapobjectscale
			s.frame = A|FF_FULLBRIGHT|FF_PAPERSPRITE
			s.color = tsrb2kr.ReturnTeamColor(v.tsr.team)
			s.angle = v.mo.angle + ANG1*90
			s.flags2 = $|MF2_DONTDRAW
			s.tics = -1
			v.mo.tsr_skimboostmobj = s
			tsrb2kr.FlipFromObject(s, v.mo)
			S_StartSound(v.mo, sfx_nbmper)
		end
	end
end

tsrb2kr.Skimboosts_PlayerThinker = function(p)
	local mo = p.mo
	if not (mo.tsr_skimboost and mo.tsr_skimboostmobj)
		mo.tsr_skimboostcd = $ and $-1
		return
	end
	
	if (p.kartstuff[k_spinouttimer] or p.kartstuff[k_squishedtimer]) then return end	-- still spun out... wait (...)

	if (mo.tsr_skimboostmobj)	-- we have a skimboost mobj.
	and not (mo.tsr_skimboostmobj.valid)	-- correction, HAD, that means its animation's over since it's disappeared!
	and (P_IsObjectOnGround(mo))
		-- delay skimboost if braking while NOT accelerating
		if not (p.cmd.buttons & BT_ACCELERATE)
			if (p.cmd.buttons & BT_BRAKE)
				mo.colorized = (leveltime%4 == 0) and true or false
				return
			end
		end
		-- boost the player
		K_DoSneaker(p)
		p.kartstuff[k_sneakertimer] = ($/2) + 5
		
		-- reset vars
		mo.tsr_skimboost = false
		mo.tsr_skimboostmobj = nil
		mo.colorized = false
		
		-- give ultimate meter!
		tsrb2kr.FillUltimate(mo.tsr_skimboostplayer, 64, "SKIMBOOST!", {tsrb2kr.ColorToMap(tsrb2kr.ReturnTeamColor(p.tsr.team), true)}, sfx_ncitem)
		mo.tsr_skimboostplayer = nil
	end
end

tsrb2kr.Framework_HandleSkimboosts = function(p)
	if not (p.tsr.team) then return end
	if (leveltime < TICRATE*5 + 6*TICRATE + (3*TICRATE/4)) then return end
	-- ^ give the level some time to start so we don't get skim boosted right at the start, that'd be dumb
	
	local mo = p.mo
	if not (mo and mo.valid) then return end
	
	tsrb2kr.Skimboosts_SpawnIndicator(p)
	tsrb2kr.Skimboosts_HelpTeammates(p)
	tsrb2kr.Skimboosts_PlayerThinker(p)
end