-- everything transfer related
tsrb2kr.Transfers_SetupTables = function()
	if (server.tsr_server.transfers) then return end
	
	server.tsr_server.transfers = {}
	for i = 1, 5
		server.tsr_server.transfers[i] = {0, 0, 0, 0, 0}
		-- ^ {transfer timer, requesting player for requests, type (1: give, 2: request), transfer cooldown, anti message spam}
	end
end

tsrb2kr.Transfers_StoredItems = function(p)
	-- check if we have to roll an item:
	if (p.tsr.storeditem)
		if not (p.kartstuff[k_itemheld])
		and not (p.kartstuff[k_itemtype])
		and not (p.kartstuff[k_itemamount])
		and not (p.kartstuff[k_itemroulette])
		and not (p.kartstuff[k_itemheld])
		and not (p.kartstuff[k_growshrinktimer] > 0)
		and not (p.kartstuff[k_rocketsneakertimer])
		and not (p.kartstuff[k_eggmanheld])
		and not (p.kartstuff[k_eggmanexplode])
		and not (p.tsr.eggmanexplodebuffer)
			-- no item: reroll the roulette
			p.kartstuff[k_itemroulette] = 1
			p.kartstuff[k_roulettetype] = 1	-- karma item
			p.tsr.storeditem = nil
		end
	end
	-- just so we dont instantly lose our item
	p.tsr.eggmanexplodebuffer = p.kartstuff[k_eggmanexplode] and true or false
end

tsrb2kr.Transfers_AutoCancels = function(p, teamtransfer)
	if (teamtransfer[2] != p) then return end
	
	if (teamtransfer[3] == 1)	-- giving an item
		p.pflags = $|PF_ATTACKDOWN	-- boom, don't attack
		if not (p.kartstuff[k_itemtype])	-- we dont have an item anymore
			teamtransfer[1] = 1	-- kill the timer this frame
		end
	elseif (teamtransfer[3] == 2)	-- requesting an item
		if (p.kartstuff[k_itemroulette])	-- we're about to get an item
		or (p.kartstuff[k_itemtype])	-- we magically got an item
			teamtransfer[1] = 1	-- kill the timer this frame
		end
	end
end

tsrb2kr.Transfers_Answer = function(p, teamtransfer)
	if (teamtransfer[2] == p) -- we started it, we can cancel it
		teamtransfer[1] = 0
		teamtransfer[2] = 0
		teamtransfer[3] = 0
		return
	end

	if (teamtransfer[3] == 2) -- it's a request
		if (not p.kartstuff[k_itemtype] or p.kartstuff[k_itemheld]) then return end
		
		teamtransfer[1] = 0
		teamtransfer[3] = 0

		p.kartstuff[k_itemtype] = 0
		p.kartstuff[k_itemamount] = 0

		tsrb2kr.FillUltimate(p, 80, "TRANSFER!", {tsrb2kr.ColorToMap(tsrb2kr.ReturnTeamColor(p.tsr.team), true)}, sfx_ncitem)

		teamtransfer[4] = TICRATE*8
		teamtransfer[2].tsr.storeditem = true
		teamtransfer[2] = nil
	else -- it's an offering
		if (p.tsr.storeditem) then return end
		
		-- sap the item away from the player that gave it to us
		teamtransfer[2].kartstuff[k_itemtype] = 0
		teamtransfer[2].kartstuff[k_itemamount] = 0

		tsrb2kr.FillUltimate(teamtransfer[2], 80, "TRANSFER!", {tsrb2kr.ColorToMap(tsrb2kr.ReturnTeamColor(p.tsr.team), true)}, sfx_ncitem)

		teamtransfer[1] = 0
		teamtransfer[2] = 0
		teamtransfer[3] = 0
		teamtransfer[4] = TICRATE*8

		p.tsr.storeditem = true
	end
end

tsrb2kr.Transfers_Start = function(p, teamtransfer)
	if (teamtransfer[4]) then return end
	
	if (p.kartstuff[k_itemtype]) -- we got an item to offer
		if (p.kartstuff[k_itemheld]) then return end	-- cant be using it
		
		teamtransfer[1] = 5*TICRATE
		teamtransfer[2] = p
		teamtransfer[3] = 1
		if not teamtransfer[5]
			for k, v in ipairs(server.tsr_server.teams[p.tsr.team])
				S_StartSound(nil, sfx_radio, v)
			end
			teamtransfer[5] = 2*TICRATE
		end
	else -- we need an item
		if (p.tsr_storeditem) then return end	-- we cant already have an item
		if (p.exiting) then return end	-- we dont need an item after finishing
		
		teamtransfer[1] = 5*TICRATE
		teamtransfer[2] = p
		teamtransfer[3] = 2
		if not teamtransfer[5]
			for k, v in ipairs(server.tsr_server.teams[p.tsr.team])
				S_StartSound(nil, sfx_radio, v)
			end
			teamtransfer[5] = 2*TICRATE
		end
	end
end

tsrb2kr.Transfers_Custom1 = function(p, teamtransfer)
	if (p.tsr.inputs[BT_CUSTOM1] == 1)	-- we just pressed custom 1
		-- we are fucking ALONE
		-- we can only give our items to charity
		if (#server.tsr_server.teams[p.tsr.team] == 1)
			if (p.kartstuff[k_itemtype])
			and not (p.kartstuff[k_itemheld])
			and not (teamtransfer[4])
				p.kartstuff[k_itemtype] = 0
				p.kartstuff[k_itemamount] = 0
				teamtransfer[4] = TICRATE*8
				
				-- fill ultimate accordingly
				local multiplier = max(1, (p.kartstuff[k_position]*16)/tsrb2kr.GetPlayerCount())
				tsrb2kr.FillUltimate(p, 14*multiplier, "CHARITY!", {tsrb2kr.ColorToMap(tsrb2kr.ReturnTeamColor(p.tsr.team), true)}, sfx_ncitem)
			end
			
			return
		end

		if (teamtransfer[1]) -- we got a timer going
			tsrb2kr.Transfers_Answer(p, teamtransfer)
		else
			tsrb2kr.Transfers_Start(p, teamtransfer)
		end
	end
end

tsrb2kr.Transfers_RunTimers = function()
	for i = 1, 5 -- go through teams to check if there's transfers going on
		local teamtransfer = server.tsr_server.transfers[i]
		teamtransfer[4] = $ and $-1
		teamtransfer[5] = $ and $-1
		
		if not (teamtransfer[1]) then continue end
		teamtransfer[1] = $-1	-- decrease timer
		
		-- timer just ended
		if not (teamtransfer[1])
			teamtransfer[2] = 0
			teamtransfer[3] = 0
		end
	end
end

tsrb2kr.Framework_HandleTransfers = function()
	tsrb2kr.Transfers_SetupTables()
	
	for p in players.iterate
		local mo = p.mo
		if not (mo and mo.valid) then continue end	-- no, spectators shouldn't be able to transfer items you dunce
		local teamtransfer = server.tsr_server.transfers[p.tsr.team]
		
		tsrb2kr.Transfers_StoredItems(p)
		tsrb2kr.Transfers_AutoCancels(p, teamtransfer)
		tsrb2kr.Transfers_Custom1(p, teamtransfer)
	end
	tsrb2kr.Transfers_RunTimers()
end