tsrb2kr.HUD_TrivialElements = function()
	local trivialHUD = {"time", "minirankings", "item", "speedometer", "position", "gametypeinfo", "check"}
	for i = 1, #trivialHUD do hud.disable(trivialHUD[i]) end
end

tsrb2kr.HUD_DrawItems = function(v, p)
	-- splitscreen makes me want to commit die: the sequel
	-- now with a threequel
	local x, y = 265, 5
	if (splitscreen)
		x, y = 270, -1
		if ((splitscreen) > 1)
			x, y = 121, -8
		end
	end

	local scale = ((splitscreen) == 1) and FRACUNIT*5/7 or FRACUNIT
	local scaleShift = 0
	if ((splitscreen) == 1)
		scaleShift = 6
	end

	--local transferring = (server.tsr_transfers[p.tsr_team][2] == p)
	local transferring = false
	local flags = tsrb2kr.ReturnSplitFlags(V_SNAPTORIGHT|V_SNAPTOTOP|V_HUDTRANS, tsrb2kr.IsDisplayPlayer(p))

	v.draw(x, y, v.cachePatch("K_TSRBG"..((splitscreen) and ((splitscreen) > 1 and 3 or 2) or 1)), flags, v.getColormap(-1, tsrb2kr.ReturnTeamColor(p.tsr.team)))

	local itemPatchs = {"K_ITSHOE", "K_ITBANA", "K_ITORB1", "K_ITMINE", "K_ITGROW", "K_ITHYUD", "K_ITRSHE", "K_ITJAWZ", "K_ITSPB", "K_ITSHRK", "K_ITINV"..leveltime%21/3+1, "K_ITEGGM", "K_ITBHOG", "K_ITTHNS"}
	if ((splitscreen) > 1)
		itemPatchs = {"K_ISSHOE", "K_ISBANA", "K_ISORBN", "K_ISMINE", "K_ISGROW", "K_ISHYUD", "K_ISRSHE", "K_ISJAWZ", "K_ISSPB", "K_ISSHRK", "K_ISINV"..leveltime%18/3+1, "K_ISEGGM", "K_ISBHOG", "K_ISTHNS"}
	end

	if (p.kartstuff[k_itemroulette])
		v.drawScaled((x+scaleShift)<<FRACBITS, (y+scaleShift)<<FRACBITS, scale, v.cachePatch(itemPatchs[p.kartstuff[k_itemroulette]%42/3+1]), flags, v.getColormap(TC_RAINBOW, p.skincolor))
	end

	local blinkColours = {SKINCOLOR_RED, leveltime%SKINCOLOR_LILAC+1}

	if (p.kartstuff[k_itemtype])
		local numberPatches = {"K_ITSHOE", "K_ITRSHE", "K_ITINV"..leveltime%21/3+1, "K_ITBANA", "K_ITEGGM", "K_ITORB"..max(1, min(4, p.kartstuff[k_itemamount])), "K_ITJAWZ", "K_ITMINE", "K_ITBHOG", "K_ITSPB", "K_ITGROW", "K_ITSHRK", "K_ITTHNS", "K_ITHYUD", "K_ITPOGO", "K_ITSINK"}
		if ((splitscreen) > 1)
			numberPatches = {"K_ISSHOE", "K_ISRSHE", "K_ISINV"..leveltime%18/3+1, "K_ISBANA", "K_ISEGGM", "K_ISORBN", "K_ISJAWZ", "K_ISMINE", "K_ISBHOG", "K_ISSPB", "K_ISGROW", "K_ISSHRK", "K_ISTHNS", "K_ISHYUD", "K_ISPOGO", "K_ISSINK"}
		end

		-- multiple item overlay
		if (p.kartstuff[k_itemamount] > 1 and not (not (splitscreen > 1) and (p.kartstuff[k_itemtype] == KITEM_ORBINAUT and p.kartstuff[k_itemamount] < 5)))
			local pp = v.cachePatch(splitscreen and (splitscreen > 1 and "K_ISMUL" or "K_TSRML2") or "K_TSRML1")

			local flipflag, flipshift = 0, 0
			if ((splitscreen > 1))
				flipflag, flipshift = V_FLIP, (pp.width)-1
			end
			v.draw(x+flipshift, y, pp, flipflag|flags)
		end
		-- the item
		if not ((p.kartstuff[k_itemheld] or transferring) and leveltime%2) and not (p.kartstuff[k_stealingtimer] > 0 and leveltime%3) then v.drawScaled((x+scaleShift)<<FRACBITS, (y+scaleShift)<<FRACBITS, (splitscreen) == 1 and FRACUNIT*5/7 or FRACUNIT, v.cachePatch(numberPatches[p.kartstuff[k_itemtype]] or "K_ITSAD"), flags, v.getColormap((p.kartstuff[k_itemblink] and leveltime%2) and -6 or -1, (p.kartstuff[k_itemblink] and leveltime%2) and (blinkColours[p.kartstuff[k_itemblinkmode]] or SKINCOLOR_WHITE) or SKINCOLOR_NONE)) end
		-- how much of the item
		if (p.kartstuff[k_itemamount] > 1)
			if not (not (splitscreen > 1) and (p.kartstuff[k_itemtype] == KITEM_ORBINAUT and p.kartstuff[k_itemamount] < 5))
				if ((splitscreen) > 1)
					v.drawString(x+2, y+31, "x"..p.kartstuff[k_itemamount], flags|V_ALLOWLOWERCASE)
				else
					local coords = (splitscreen) and {x-1, y+36} or {x-7, y+41}

					v.draw(coords[1], coords[2], v.cachePatch("K_ITX"), flags)
					tsrb2kr.DrawMKText(v, p.kartstuff[k_itemamount], coords[1]+10, coords[2]-5, flags, "left")
				end
			end
		end
	end

	-- flashing icons and timer bars (EXTREMELY optimized)
	local timerChecks = {
		{{k_stealingtimer, "HYUD", 3}, {k_stolentimer, "HYUD", 3}, {k_sadtimer, "SAD", 3}, {k_growshrinktimer, "GROW", 2, {k_growcancel, 26}}}, -- > 0 timers
		{{k_eggmanexplode, "EGGM", 2}, {k_rocketsneakertimer, "RSHE", 2, {k_rocketsneakertimer, 814}}} -- > 1 timers
	}

	for t = 1, 2
		for i = 1, #timerChecks[t]
			local c = timerChecks[t][i]
			-- flashing icons
			if (p.kartstuff[c[1]] > (t-1) and leveltime%c[3])
				v.drawScaled((x+scaleShift)<<FRACBITS, (y+scaleShift)<<FRACBITS, scale, v.cachePatch("K_I"..(splitscreen > 1 and "S" or "T")..timerChecks[t][i][2]), flags)
			end

			-- 265, 5
			-- 276, 40
			-- timer bars
			if c[4] and p.kartstuff[c[4][1]] > 0
				local coords = {x+11, y+35}
				if (splitscreen)
					coords = {x+14, y+31}
					if ((splitscreen) > 1)
						coords = {x+17, y+27}
					end
				end

				-- main bar
				v.draw(coords[1], coords[2], v.cachePatch(splitscreen and (splitscreen > 1 and "K_ISIMER" or "K_TSRMER") or "K_ITIMER"), flags)

				-- borders
				local length = (splitscreen and (splitscreen > 1 and 12 or 19) or 26)

				v.drawFill(coords[1]+1, coords[2]+1, p.kartstuff[c[4][1]]*length/c[4][2], 1, 120|flags)
				if not (splitscreen > 1) then v.drawFill(coords[1]+1, coords[2]+2, p.kartstuff[c[4][1]]*length/c[4][2], 1, 8|flags) end
				v.drawFill(coords[1]+1, coords[2]+1, 1, (splitscreen > 1 and 1 or 2), 12|flags)
				if (p.kartstuff[c[4][1]]*length/c[4][2] > 0) then v.drawFill(coords[1]+p.kartstuff[c[4][1]]*length/c[4][2], coords[2]+1, 1, (splitscreen > 1 and 1 or 2), 12|flags) end
			end
		end
	end

	-- special case: eggbox timer
	if (p.kartstuff[k_eggmanexplode] > 1)
		v.draw(x+(splitscreen > 1 and 16 or 17), y+(splitscreen > 1 and 11 or 13), v.cachePatch("K_EGGN"..min(3, G_TicsToSeconds(p.kartstuff[k_eggmanexplode]))), flags)
	end

	-- p1's stored item:
	if (p.tsr.storeditem)
	and (leveltime%8) >= 4
		local hx, hy, scale = x+4, y+53, FRACUNIT/4
		if (splitscreen)
			hx, hy, scale = x+8, y+47, FRACUNIT/5
			if (splitscreen > 1)
				hx, hy, scale = x+14, y+34, FRACUNIT/6
			end
		end

		v.drawScaled(hx<<FRACBITS, hy<<FRACBITS, scale, v.cachePatch("RNDMA0"), flags)
	end
end

tsrb2kr.HUD_DrawLaps = function(v, p)
	if (splitscreen > 1)
		local flags = tsrb2kr.ReturnSplitFlags(V_SNAPTOTOP|V_SNAPTORIGHT, tsrb2kr.IsDisplayPlayer(p))
		local txt = (p.laps+1) > (numlaps) and "FIN" or (p.laps+1).."/"..(numlaps)

		local strw = v.stringWidth(txt)

		v.drawString(131, 5, txt, flags|V_HUDTRANS, "right")
		-- draw the lap flag
		local pp = v.cachePatch("K_SPTLAP")
		v.draw(131-strw-(pp.width+1), 5, pp, flags|V_HUDTRANS)
	else
		local x, y = 193, 9
		if (splitscreen)
			x, y = 202, 7
		end
		local flags = tsrb2kr.ReturnSplitFlags(V_SNAPTOTOP|V_SNAPTORIGHT, tsrb2kr.IsDisplayPlayer(p))

		v.draw(x, y, v.cachePatch("K_TSRLAP"), flags|V_HUDTRANS)
		tsrb2kr.DrawMKText(v, (p.laps+1) > (numlaps) and "FIN" or (p.laps+1).."/"..(numlaps), x+30, y+3, flags|V_HUDTRANS, "left")
	end
end

tsrb2kr.Framework_HUD = function(v, p, c)
	tsrb2kr.HUD_TrivialElements()
	
	if not (leveltime > 105) then return end	-- everything else is after this leveltime
	if (server.tsr_server.finishstate)
		tsrb2kr.HUD_DrawResults(v, p)
		return
	else
		tsrb2kr.HUD_DrawCheck(v, p)
	end
	tsrb2kr.HUD_DrawRankings(v, p)
	
	if not (p.tsr.team) then return end
	tsrb2kr.HUD_DrawTransfers(v, p)
	tsrb2kr.HUD_DrawItems(v, p)
	tsrb2kr.HUD_DrawLaps(v, p)
	
	if not (p.mo and p.mo.valid) then return end
	tsrb2kr.HUD_DrawStatus(v, p, 1, p)
	tsrb2kr.HUD_DrawTeammates(v, p)
end