tsrb2kr.HUD_DrawResults = function(v, p)
	-- draw a fade screen first:
	v.fadeScreen(65280, 16)	-- 0xFF00

	local t = server.tsr_server.finishtimer
	
	-- rankings + lines
	v.drawString(160, 12, "* TEAM RANKINGS *", 0, "center")
	local dupadjust = (v.width()/v.dupx())
	local duptweak = (dupadjust - 320)/2	-- BASEDVIDWIDTH = 320
	v.drawFill(1-duptweak, 26, dupadjust-2, 1, 0)	-- horizontal
	v.drawFill(160, 26, 1, 162, 0)	-- vertical

	-- draw players:
	for i = 1, #server.tsr_server.finishrankings
		-- get info:
		local info = server.tsr_server.finishrankings[i]
		local x = min(20, -96 + t*32 - 64*(i-1))
		local y = 28 + (i-1)*10

		-- get remaining info:
		local name = info and info.name or "NULL"
		local skin = info and info.skin or "sonic"
		local color = info and info.color or SKINCOLOR_NONE
		local rank = info and info.rank or 16
		local points = info and info.score or "No Contest."
		
		-- rank:
		v.drawString(x, y+1, rank, 0, "right")
		-- draw skin icon
		local pp = skins[skin].facerank
		v.drawScaled((x+1)<<FRACBITS, (y+1)<<FRACBITS, FRACUNIT/2, v.cachePatch(pp), 0, v.getColormap(skin, color))
		-- name:
		v.drawString(x+10, y, name, V_6WIDTHSPACE|V_ALLOWLOWERCASE, "thin")
		-- points:
		v.drawString(x+137, y, points, V_6WIDTHSPACE, "thin-right")
	end

	-- now, the bars to the side which show the scores
	local t2 = t
	t = $- TICRATE

	local c = {
		tsrb2kr.ColorToMap(tsrb2kr.ReturnTeamColor(1)),
		tsrb2kr.ColorToMap(tsrb2kr.ReturnTeamColor(2)),
		tsrb2kr.ColorToMap(tsrb2kr.ReturnTeamColor(3)),
		tsrb2kr.ColorToMap(tsrb2kr.ReturnTeamColor(4)),
		tsrb2kr.ColorToMap(tsrb2kr.ReturnTeamColor(5))
	}
	//local cb = {230, 126, 112, 164, 85, 0}
	local cb = {120, 5, 15, 21, 31, 22, 14, 32, 179, 202, 34, 36, 52, 54, 61, 124, 146, 151, 148, 152, 134, 127, 125, 126, 136, 137, 99, 85, 87, 127, 90, 89, 83, 88, 92, 94, 155, 85, 72, 68, 97, 113, 252, 119, 61, 106, 102, 113, 176, 107, 84, 114, 160, 168, 176, 178, 180, 182, 169, 163, 165, 167, 184, 187, 162, 186, 167, 220, 216, 214, 216, 210, 217, 215, 218, 11, 201, 202, 113, 203, 53, 205, 215, 227, 230, 235, 248, 249, 196, 192, 204, 192, 193, 126, 10, 113, 248, 254, 148, 122}

	for i = 1, #server.tsr_server.teams
		if not server.tsr_server.teams[i][1] or not server.tsr_server.teams[i][1].valid
			continue
		end

		-- coords:
		local x = min(176 + 28*(i-1), t*32)
		local y = 57

		-- background + name:
		v.drawFill(x, y, 18, 100, 24)
		
		local teamname = tsrb2kr.ReturnTeamName(i)
		if (teamname:len() > 6)
			teamname = $:sub(1, 5)..".."
		end
		local w = v.stringWidth(teamname, V_ALLOWLOWERCASE|V_6WIDTHSPACE, "thin")
		v.drawString(x+9 - (w/2), 44, c[i]..teamname, V_ALLOWLOWERCASE|V_6WIDTHSPACE, "thin")

		local score = 0
		-- start filling the bars eventually
		for j = #server.tsr_server.finishteamscore[i], 1, -1
			local info = server.tsr_server.finishteamscore[i][j]
			-- max # of points we can get is 46: 18 + 15 + 13. Bumped to 64 for safety
			-- we have 128 - 2 px to work with = 126... do the math you fucking computer!

			local dy = 156 - (info.displayscore*2)
			local h = (info.displayscore*2)

			score = $ + info.displayscore - info.addedscore

			-- mmmh... let's do it!
			v.drawFill(x+1, dy, 16, h, cb[tsrb2kr.ReturnTeamColor(i)])
		end

		-- 2nd iteration... to draw character potraits
		for j = #server.tsr_server.finishteamscore[i], 1, -1
			local info = server.tsr_server.finishteamscore[i][j]
			-- max # of points we can get is 46: 18 + 15 + 13. Let's bump this margin to 64 for safety
			-- we have 128 - 2 px to work with = 126... do the math you fucking computer!

			local dy = 156 - (info.displayscore*2)

			-- mmmh... let's do it!
			v.drawFill(x, dy, 18, 1, 24)
			-- draw the portrait as well
			local skin = info and info.skin or "sonic"
			local pp = skins[skin].facerank
			local color = info and info.color or SKINCOLOR_NONE
			v.drawScaled((x-8)<<FRACBITS, (dy-4)<<FRACBITS, FRACUNIT/2, v.cachePatch(pp), 0, v.getColormap(skin, color))
		end

		-- finally, display the score at the bottom
		local w = v.stringWidth(score, V_6WIDTHSPACE, "thin")
		v.drawString(x+9 - (w/2), 146, score, V_6WIDTHSPACE, "thin")

		-- now, the final rankings
		if t2 > TICRATE*2 + 128
			for j = 1, #server.tsr_server.finishteamrankings

				local req = TICRATE*2 + 128 + (j*17)
				if t2 >= req
				and server.tsr_server.finishteamrankings[j] == i

					local pos = 6-j
					-- if there's a tie, just grab the rank of the next team over;
					-- constantly check over and over so we can get multiple ties if need be
					local nextteam_i = 1
					local nextteam = server.tsr_server.finishteamrankings[j+nextteam_i]

					while (nextteam)
						if (tsrb2kr.ReturnFinishTeamScore(server.tsr_server.finishteamrankings[j]) == tsrb2kr.ReturnFinishTeamScore(nextteam))
							pos = 6-(j+nextteam_i)
						end
						-- search for the next team in line
						nextteam_i = $+1
						nextteam = server.tsr_server.finishteamrankings[j+nextteam_i]
					end

					local pp = "K_POSN"..pos.."0"
					if j == #server.tsr_server.finishteamrankings or pos == 1
						pp = "K_POSNW"..(leveltime%11 / 2)
					end

					local s = FRACUNIT*3 - (t2- req)*FRACUNIT/2
					local scale = max(FRACUNIT/2, s)
					local patch = v.cachePatch(pp)
					
					local xpos = x + 20
					local ypos = y + 131

					v.drawScaled(xpos<<FRACBITS, ypos<<FRACBITS, scale, patch, V_HUDTRANSHALF)
				end
			end
		end
	end
end