tsrb2kr.HUD_DrawStatus = function(v, localp, index, p)
	local coords = {{5, 5}, {5, 145}, {265, 145}}
	if (splitscreen) -- adjust coords for splitscreen
		coords = {{1, -1}, {1, 52}, {270, 52}}
		if (splitscreen) > 1
			coords = {{-9, -8}, {-9, 62}, {121, 62}}
		end
	end

	local possibleFlags = {V_SNAPTOTOP|V_SNAPTOLEFT, V_SNAPTOBOTTOM|V_SNAPTOLEFT, V_SNAPTOBOTTOM|V_SNAPTORIGHT}
	local x, y = coords[index][1], coords[index][2]

	local flags = possibleFlags[index]
	if (splitscreen) -- adjust flags for splitscreen
		flags = tsrb2kr.ReturnSplitFlags(possibleFlags[index], tsrb2kr.IsDisplayPlayer(localp))
	end

	local ultcharge, ultcharge_anim = server.tsr_server.ultimates[p.tsr.team], p.tsr.ultimategauge
	-- force this if we have our buffer
	if (p.tsr.ultimatebuffer) then ultcharge = 1000 end

	-- draw overlay here
	local itcolor = tsrb2kr.ReturnTeamColor(p.tsr.team)
	if (ultcharge >= 1000 or p.mo.tsr_ultimateon)
		itcolor = leveltime & 1 and SKINCOLOR_YELLOW or SKINCOLOR_ORANGE
	end
	v.draw(x, y, v.cachePatch("K_TSRBG"..((splitscreen) and ((splitscreen) > 1 and 3 or 2) or 1)), flags|V_HUDTRANS, v.getColormap(-1, itcolor))
	
	-- stroke around the overlay
	local teamtransfer = server.tsr_server.transfers[p.tsr.team]
	
	local stroke_num
	if (p.tsr.ultimateget and p.tsr.ultimateget%8 >= 4)
		stroke_num = 1
	elseif (p.tsr.decayedultimate)
		local decay_timer = (1000-p.tsr.decayedultimate)/2
		if (decay_timer and decay_timer%8 >= 4)
			stroke_num = 2
		end
	elseif (teamtransfer[1] and (teamtransfer[2] == p) and leveltime%8 >= 4)
		stroke_num = 3
	end
	
	if (stroke_num)
		v.draw(x, y, v.cachePatch("K_TSRS"..stroke_num..((splitscreen) and ((splitscreen) > 1 and 3 or 2) or 1)), flags|V_HUDTRANS)
	end
	
	-- draw ultimate gauge here:
	local length = ultcharge_anim*((splitscreen) and ((splitscreen) > 1 and 18 or 25) or 34)/1000

	local color = ((p.mo.tsr_ultimateon) and leveltime%2) and 87 or 104
	if ultcharge < 1000 and not p.mo.tsr_ultimateon
	or p.tsr.decayedultimate
		color = 114
	end

	local hx, hy = x+8, (y+42)-length
	if (splitscreen) -- adjust hx and hy for splitscreen
		hx, hy = x+12, (y+37)-length
		if (splitscreen) > 1
			hx, hy = x+15, (y+32)-length
		end
	end
	v.drawFill(hx, hy, ((splitscreen) and ((splitscreen) > 1 and 18 or 25) or 34), length, color|flags)
	
	-- ultimate is decaying:
	if p.tsr.decayedultimate
		local length = p.tsr.decayedultimate*((splitscreen) and ((splitscreen) > 1 and 18 or 25) or 34)/1000

		local hx, hy = x+8, (y+42)-length
		if (splitscreen) -- adjust hx and hy for splitscreen
			hx, hy = x+12, (y+37)-length
			if (splitscreen) > 1
				hx, hy = x+15, (y+32)-length
			end
		end

		local decay_colours = {127, 124, 122, 124}
		local decay_colours_timer = (1000-p.tsr.decayedultimate)/2
		local decay_colour = decay_colours[(decay_colours_timer%8)/2+1]
		v.drawFill(hx, hy, ((splitscreen) and ((splitscreen) > 1 and 18 or 25) or 34), length, decay_colour|flags)
	end


	-- draw portrait here:
	local pp = v.cachePatch((splitscreen) > 1 and skins[p.mo.skin].facerank or skins[p.mo.skin].facewant)

	local hx, hy = x+9, y+9
	if (splitscreen) -- adjust hx and hy for splitscreen
		hx, hy = x+13, y+13
		if (splitscreen) > 1
			hx, hy = x+16, y+15
		end
	end

	local flipflag = 0
	if (index == 3)
		flipflag = V_FLIP
		hx = $+((splitscreen) == 1 and (pp.width*5/7)+1 or pp.width)
	end

	v.drawScaled(hx<<FRACBITS, hy<<FRACBITS, (splitscreen) == 1 and FRACUNIT*5/7 or FRACUNIT, pp, flags|flipflag|V_HUDTRANS, v.getColormap(p.mo.skin, p.skincolor))
	-- draw team messages here:
	if (p.tsr.teammsg and p.tsr.teammsg_time)
		local coords = {{x+47, y+37}, {x+47, y+5}, {x+3, y+5}}
		if (splitscreen) -- adjust coords for splitscreen
			coords = {{x+42, y+32}, {x+42, y+9}, {x+7, y+9}}
			if (splitscreen) > 1
				coords = {{x+37, y+29}, {x+37, y+13}, {x+12, y+13}}
			end
		end

		local param = (splitscreen) > 1 and "small" or "left"
		if (index == 3) then param = (splitscreen) > 1 and "small-right" or "right" end

		local map = ((leveltime & 1) and p.tsr.teammsg_colours[2]) and p.tsr.teammsg_colours[2] or p.tsr.teammsg_colours[1]

		local transflag = 0
		if (p.tsr.teammsg_time < 20)
			transflag = min(V_90TRANS, ((20 - p.tsr.teammsg_time)/2)*V_10TRANS)
		end

		v.drawString(coords[index][1], coords[index][2], p.tsr.teammsg, map|flags|transflag, param)
	end

	-- draw teammate's item here:
	if (index > 1) -- make sure we're not drawing for p1
	and (p.kartstuff[k_itemtype] and not p.kartstuff[k_itemheld]) -- they have an item they can offer/give
		local coords = {{x+45, y+12}, {x+4, y+12}}
		if (splitscreen) -- adjust coords for splitscreen
			coords = {{x+40, y+16}, {x+8, y+16}}
			if (splitscreen) > 1
				coords = {{x+34, y+18}, {x+13, y+18}}
			end
		end

		v.drawScaled(coords[index-1][1]<<FRACBITS, coords[index-1][2]<<FRACBITS, FRACUNIT/((splitscreen) > 1 and 6 or 4), v.cachePatch("RNDMA0"), flags)
	end

	-- draw player position here: (the hardest part)
	local s = tostring(p.kartstuff[k_position]) -- get position as a string

	local hx = (index == 3) and (x+3)-((43/2)*(s:len()-1)) or x+68
	if (splitscreen) -- adjust hx for splitscreen
		hx = (index == 3) and (x+12)-((43/2)*(s:len()-1)) or x+58
		if (splitscreen) > 1
			hx = (index == 3) and (x+12)-((43/4)*(s:len()-1)) or x+47
		end
	end

	-- reduce ternaries
	local doubleSize = ((p.laps+1) > (numlaps) or p.kartstuff[k_positiondelay])

	for i = 1, s:len()
		local n = s:sub(i, i) -- current number

		local pp = v.cachePatch("K_POSN"..n.."0") -- position patch
		-- change position patch based on final lap stuff
		if (p.laps+1) >= (numlaps)
			if ((p.laps+1) > (numlaps) and p.kartstuff[k_position] == 1)
				pp = v.cachePatch("K_POSNW"..leveltime%18/3)
			else
				local numFrames = {{0, 1, 2, 3}, {0, 4, 5, 6}} -- this is easier than ternaries making this look like spaghetti
				pp = v.cachePatch(K_IsPlayerLosing(p) and "K_POSN"..n..numFrames[2][(leveltime%12/3)+1] or "K_POSN"..n..numFrames[1][(leveltime%12/3)+1])
			end
		end

		local xpos = hx+((index < 3 and doubleSize) and pp.width/2 or 0)
		local ypos = (index > 1) and y+43 or 38+(doubleSize and pp.height/2 or 0)
		local scales = {FRACUNIT/2, FRACUNIT, FRACUNIT*3/4}
		if (splitscreen) -- adjust stuff for splitscreen
			xpos = hx+((index < 3 and doubleSize) and pp.width*3/8 or 0)
			ypos = (index > 1) and y+39 or 29+(doubleSize and pp.height*3/8 or 0)
			scales = {FRACUNIT*3/8, FRACUNIT*3/4, FRACUNIT/2}
			if (splitscreen) > 1
				xpos = hx+((index < 3 and doubleSize) and pp.width/4 or 0)
				ypos = (index > 1) and y+33 or 18+(doubleSize and pp.height/4 or 0)
				scales = {FRACUNIT/4, FRACUNIT/2, FRACUNIT*3/8}
			end
		end

		v.drawScaled(xpos<<FRACBITS, ypos<<FRACBITS, scales[doubleSize and (index == 1 and 2 or 3) or 1], pp, flags|V_HUDTRANSHALF)
		hx = $+((pp.width*scales[doubleSize and (index == 1 and 2 or 3) or 1])>>FRACBITS)
	end
end

tsrb2kr.HUD_DrawTeammateNames = function(v, p, names)
	if not (p.tsr.displayteam) then return end
	
	-- fade stuff
	local timer = 3*TICRATE-p.tsr.displayteam

	local fade
	if (timer >= 96)
		local startfade = v.localTransFlag(v)>>V_ALPHASHIFT
		fade = min(9, startfade + (timer-96))
	else
		local maxfade = v.localTransFlag(v)>>V_ALPHASHIFT    -- value of V_HUDTRANS
		fade = max(maxfade, (9 - ((timer))/2))
	end

	-- get the string we'll use
	local nameString = "*cricket noises*" -- default no teammate string, sad
	if (#names) then nameString = (#names == 2) and names[1]..", "..names[2] or names[1] end

	if (splitscreen) > 1
		local hy = 8 -- lazy
		local flags = tsrb2kr.ReturnSplitFlags(V_SNAPTOTOP|V_SNAPTOLEFT|V_SNAPTORIGHT, tsrb2kr.IsDisplayPlayer(p))

		local string1 = "YOUR TEAMMATE"..(#names == 1 and "" or "S")..":"
		v.drawString(80-(v.stringWidth(string1, 0, "thin")/2), timer<40 and (hy-7)+(timer%40/5) or hy, string1, flags|fade<<V_ALPHASHIFT, "thin")
		v.drawString(80-(v.stringWidth(nameString, 0, "thin")/2), timer<40 and ((hy+10)-7)+(timer%40/5) or hy+10, nameString, flags|fade<<V_ALPHASHIFT, "thin")
	else
		local hy = (splitscreen) and 12 or 16
		local flags = tsrb2kr.ReturnSplitFlags(V_SNAPTOTOP, tsrb2kr.IsDisplayPlayer(p))

		v.drawString(160, timer<40 and (hy-7)+(timer%40/5) or hy, "YOUR TEAMMATE"..(#names == 1 and "" or "S")..":", flags|fade<<V_ALPHASHIFT, "center")
		v.drawString(160, timer<40 and ((hy+10)-7)+(timer%40/5) or hy+10, nameString, flags|fade<<V_ALPHASHIFT, "center")
	end
end

tsrb2kr.HUD_DrawTeammates = function(v, p)
	local teamNames = {}
	if (#server.tsr_server.teams[p.tsr.team] > 1) -- make sure we have friends
		local teamDraw = 2 -- start on our 1st teammate, bottom right (index 2)
		for k, p2 in ipairs(server.tsr_server.teams[p.tsr.team])	-- cant use v in a hud hook!
			if (p2 == p) then continue end -- this is us, we're already drawn
			if not (p2.mo and p2.mo.valid) then continue end

			-- add their names to a table to use later on
			teamNames[#teamNames+1] = p2.name

			tsrb2kr.HUD_DrawStatus(v, p, teamDraw, p2)
			teamDraw = $+1 -- if we continue, we'll draw our second teammate next (index 3)
		end
	end
	
	-- display teammates when you first get them
	tsrb2kr.HUD_DrawTeammateNames(v, p, teamNames)
end