tsrb2kr.HUD_DrawTransfersSplit = function(v, p)
	local flags = tsrb2kr.ReturnSplitFlags(V_SNAPTOTOP, tsrb2kr.IsDisplayPlayer(p))
	local teamtransfer = server.tsr_server.transfers[p.tsr.team]

	local scrx = 160
	if splitscreen > 1
		scrx = 80
	end

	if teamtransfer[4]	-- cooldown
		v.drawFill((scrx/2), 19, (teamtransfer[4])/(splitscreen > 1 and 4 or 2), 2, 1|flags)
		-- timer is always TICRATE*8
		-- SERIOUSLY!?
		local strw = v.stringWidth("WAIT...", 0, "small")
		v.drawString(scrx - strw/2, 13, "WAIT...", V_HUDTRANSHALF|flags, "small")
		return
	end

	if teamtransfer[1] -- transfer stuff is going on.
		-- player name:
		local p2 = teamtransfer[2]
		if not p2 or not p2.valid or not p2.mo or not p2.mo.valid return end

		if p2 == p
			local texts = {
				"You offered an item.",
				"You requested an item.",
			}
			local txtw = v.stringWidth(texts[teamtransfer[3]],0,"small")
			v.drawString(scrx - txtw/2, 18, texts[teamtransfer[3]], flags, "small")
		else

			local txtw = v.stringWidth(p2.name, 0, "small")
			v.drawString(scrx-txtw/2, 13, "\x82"..p2.name, flags, "small")
			local texts = {
				"is offering an item.",
				"is requesting an item."
			}
			txtw = v.stringWidth(texts[teamtransfer[3]],0,"small")
			v.drawString(scrx - txtw/2, 18, texts[teamtransfer[3]], flags, "small")
		end
		-- timer + our rank icon for funsies
		local pp = v.cachePatch(skins[p2.mo.skin].facerank)
		v.drawScaled((scrx/2 - (pp.width/2))<<FRACBITS, 16<<FRACBITS, FRACUNIT/2, pp, flags, v.getColormap(p2.mo.skin, p2.skincolor))
		-- timer is always 4*TICRATE, play on that
		v.drawFill(scrx/2 + 2, 24, teamtransfer[1]/(splitscreen >1 and 2 or 1), 2, 1|flags)

		-- can we do something about the current message?
		local txt = ""
		if teamtransfer[3] == 1	-- player is OFFERING item
		and p != p2
			if not p.tsr.storeditem	-- we don't have a stored item
				txt = "C1: TAKE ITEM"
			end
		elseif teamtransfer[3] == 2	-- player is ASKING for item
		and p != p2
			if p.kartstuff[k_itemtype]
			and not p.kartstuff[k_itemheld]
				txt = "C1: GIVE ITEM"
			end
		end
		local strw = v.stringWidth(txt, 0, "small")
		v.drawString(scrx - strw/2, 24, txt, V_HUDTRANSHALF|flags, "small")
	end
end

tsrb2kr.HUD_DrawTransfers = function(v, p)
	if (splitscreen)
		tsrb2kr.HUD_DrawTransfersSplit(v, p)
		return
	end

	local teamtransfer = server.tsr_server.transfers[p.tsr.team]

	if (teamtransfer[4])	-- cooldown
		v.drawFill(96 + 16 + 2, 19, teamtransfer[4]/4, 2, 1|V_SNAPTOTOP)
		-- timer is always TICRATE*8
		v.drawString(160, 16, "COOLDOWN...", V_HUDTRANSHALF|V_SNAPTOTOP, "center")
		return
	end

	if (teamtransfer[1]) -- transfer stuff is going on.
		-- player name:
		local p2 = teamtransfer[2]
		if not p2 or not p2.valid or not p2.mo or not p2.mo.valid then return end

		if p2 == p
			local texts = {
				"You offered an item.",
				"You requested an item.",
			}
			v.drawString(160, 26, texts[teamtransfer[3]], V_SNAPTOTOP, "center")
		else

			v.drawString(160, 16, "\x82"..p2.name, V_SNAPTOTOP, "center")
			local texts = {
				"is offering an item.",
				"is requesting an item."
			}
			v.drawString(160, 26, texts[teamtransfer[3]], V_SNAPTOTOP, "center")
		end
		-- timer + our rank icon for funsies
		local pp = v.cachePatch(skins[p2.mo.skin].facerank)
		v.draw(96, 34, pp, V_SNAPTOTOP, v.getColormap(p2.mo.skin, p2.skincolor))
		-- timer is always 4*TICRATE, play on that
		v.drawFill(96 + 16 + 2, 39, teamtransfer[1]/2, 2, 1|V_SNAPTOTOP)

		-- can we do something about the current message?
		local txt = ""
		if teamtransfer[3] == 1	-- player is OFFERING item
		and p != p2
			if not (p.tsr.storeditem)	-- we don't have a stored item
				txt = "C1: TAKE ITEM"
			end
		elseif teamtransfer[3] == 2	-- player is ASKING for item
		and p != p2
			if p.kartstuff[k_itemtype]
			and not p.kartstuff[k_itemheld]
				txt = "C1: GIVE ITEM"
			end
		end

		v.drawString(160, 36, txt, V_HUDTRANSHALF|V_SNAPTOTOP, "center")
	end
end