-- tourney mode has it's own handling for this
tsrb2kr.TourneyMode_SetupRound = function()
	if (leveltime != 1) then return end	-- we want to INSTANTLY assign teams.
	
	-- assign teams
	server.tsr_server.teams = {{}, {}, {}, {}, {}}
	for i = 1, 5
		local team = server.tsr_tourneyteams[i]
		if not (#team) then continue end	-- nothing to assign in this team
		
		for j = 1, #team
			local tp = team[j]
			if not (tp and tp.valid) then continue end
			tp.tsr = {}
			
			-- stop them from being a spectator!
			tp.spectator = false
			tp.playerstate = PST_REBORN	-- make sure we're reset fully
			tp.tsr.tourneyplayer = true
			tsrb2kr.AssignTeam(tp, i)
		end
	end
end

tsrb2kr.TourneyMode_Ragespec = function()
	for i = 1, #server.tsr_server.teams
		for k, v in ipairs(server.tsr_server.teams[i])
			if not (v and v.valid)
			or (v.spectator)
				table.remove(server.tsr_server.teams[i], k)
				if (v and v.valid)
					v.tsr.team = nil
					v.tsr.tourneyplayer = nil
				end
			end
		end
	end
	
	for p in players.iterate
		-- you CANT join 
		if not (p.tsr.tourneyplayer)
		and not (p.spectator)
			p.spectator = true
			CONS_Printf(p, "\x83NOTICE:\x80 You can't join until the tourney round is over!")
		end
	end
end

tsrb2kr.TourneyMode_Sorting = function()
	server.tsr_server.sortedteams = {}
	local sortedteams = server.tsr_server.sortedteams	-- laziness ahoy
	
	-- get the teams scores (and make sure team is valid too a.k.a has members) and get them sorted
	for i = 1, 5 
        if not #server.tsr_server.teams[i] then continue end
        sortedteams[#sortedteams+1] = {i, tsrb2kr.ReturnTeamPoints(i)}
    end
    table.sort(sortedteams, function(a, b) return (a[2] or 0) > (b[2] or 0) end)
	
	-- now we store their absolute ranks, ties accounted for
	// this makes the code into a mess. ...Too bad!
	for i = 1, #sortedteams
		local pos = i
		
		-- if there's a tie, just grab the rank of the prev team;
		-- constantly check over and over so we can get multiple ties if need be
		local prevteam_i = 1
		local prevteam = sortedteams[i-prevteam_i]

		while (prevteam)
			if (sortedteams[i][2] == prevteam[2])
				pos = i-prevteam_i
			end
			-- search for the next team in line
			prevteam_i = $+1
			prevteam = sortedteams[i-prevteam_i]
		end

		sortedteams[i][3] = pos
	end
end

tsrb2kr.TourneyMode_Recognition = function(p)
	-- team colours
	if (tsrb2kr.cv_tc.value)
		if (p.tsr.team)
			p.tsr.oldskincolor = $ or p.skincolor

			tsrb2kr.SmartSetColor(p, false, tsrb2kr.ReturnTeamColor(p.tsr.team))
			p.skincolor = tsrb2kr.ReturnTeamColor(p.tsr.team)
		else
			if (p.tsr.oldskincolor)
				tsrb2kr.SmartSetColor(p, false, p.tsr.oldskincolor)
				p.skincolor = p.tsr.oldskincolor

				p.tsr.oldskincolor = nil
			end
		end
	else
		if (p.tsr.oldskincolor)
			tsrb2kr.SmartSetColor(p, false, p.tsr.oldskincolor)
			p.skincolor = p.tsr.oldskincolor

			p.tsr.oldskincolor = nil
		end
	end
	
	-- all of this is team related functions
	if not (p.tsr.team) then return end
	p.tsr.displayteam = $ and $-1
	
	-- we need mo to be valid here on
	local mo = p.mo
	if not (mo and mo.valid) then return end
	
	if not mo.tsr_marker or not mo.tsr_marker.valid
		mo.tsr_marker = P_SpawnMobj(mo.x, mo.y, mo.z, MT_TSR_MARKER)
		mo.tsr_marker.target = mo
		mo.tsr_marker.color = tsrb2kr.ReturnTeamColor(p.tsr.team)
		mo.tsr_marker.flags2 = $|MF2_DONTDRAW
	end
end

tsrb2kr.TourneyMode_HandleTeams = function()
	tsrb2kr.TourneyMode_SetupRound()
	tsrb2kr.TourneyMode_Ragespec()
	tsrb2kr.TourneyMode_Sorting()
	for p in players.iterate
		tsrb2kr.TourneyMode_Recognition(p)
	end
end