-- main definitions script (namespace, functions)
rawset(_G, "tsrb2kr", {})	-- from a gamemode check to a namespace, they grow up so fast....

-- functions
tsrb2kr.GetPlayerCount = function(unassigned, spectators)
	local pnum = 0
	for p in players.iterate
		if (p.spectator and not (spectators)) then continue end
		if ((unassigned) and p.tsr.team) then continue end
		
		pnum = $+1
	end

	return pnum
end

tsrb2kr.ReturnTeamColor = function(team)
	local c = {tsrb2kr.cv_t1c.value, tsrb2kr.cv_t2c.value, tsrb2kr.cv_t3c.value, tsrb2kr.cv_t4c.value, tsrb2kr.cv_t5c.value, SKINCOLOR_NONE}
	if (server.tsr_server.tourneyround)
		local tourney_colours = server.tsr_tourneycolours
		c = {tourney_colours[1], tourney_colours[2], tourney_colours[3], tourney_colours[4], tourney_colours[5]}
	end
	
	return c[team]
end

tsrb2kr.ColorToString = function(c)
	local strings = {"White", "Silver", "Grey", "Nickel", "Black", "Skunk", "Fairy", "Popcorn", "Artichoke", "Pigeon", "Sepia", "Beige", "Walnut", "Brown", "Leather", "Salmon", "Pink", "Rose", "Brick", "Cinnamon", "Ruby", "Raspberry", "Cherry", "Red", "Crimson", "Maroon", "Lemonade", "Flame", "Scarlet", "Ketchup", "Dawn", "Sunset", "Creamsicle", "Orange", "Pumpkin", "Rosewood", "Burgundy", "Tangerine", "Peach", "Caramel", "Cream", "Gold", "Royal", "Bronze", "Copper", "Quarry", "Yellow", "Mustard", "Crocodile", "Olive", "Vomit", "Garden", "Lime", "Handheld", "Tea", "Pistachio", "Moss", "Camouflage", "Robo-Hood", "Mint", "Green", "Pinetree", "Emerald", "Swamp", "Dream", "Plague", "Algae", "Caribbean", "Azure", "Aqua", "Teal", "Cyan", "Jawz", "Cerulean", "Navy", "Platinum", "Slate", "Steel", "Thunder", "Rust", "Wristwatch", "Jet", "Sapphire", "Periwinkle", "Blue", "Blueberry", "Nova", "Pastel", "Moonslam", "Ultraviolet", "Dusk", "Bubblegum", "Purple", "Fuchsia", "Toxic", "Mauve", "Lavender", "Byzantium", "Pomegranate", "Lilac"}
	return strings[tonumber(c)]
end

tsrb2kr.ReturnTeamName = function(team)
	local tnames = {
	tsrb2kr.ColorToString(tsrb2kr.ReturnTeamColor(1)),
	tsrb2kr.ColorToString(tsrb2kr.ReturnTeamColor(2)),
	tsrb2kr.ColorToString(tsrb2kr.ReturnTeamColor(3)),
	tsrb2kr.ColorToString(tsrb2kr.ReturnTeamColor(4)),
	tsrb2kr.ColorToString(tsrb2kr.ReturnTeamColor(5))
	}
	if (server.tsr_server.tourneyround)
		local tourney_tnames = server.tsr_tourneynames
		tnames = {tourney_tnames[1], tourney_tnames[2], tourney_tnames[3], tourney_tnames[4], tourney_tnames[5]}
	end
	
	return tnames[team]
end

tsrb2kr.ColorToMap = function(c, vflag)
	local colour_sets = {
	{SKINCOLOR_WHITE, SKINCOLOR_SILVER, SKINCOLOR_SLATE}, -- 1: No colour mapping
	{SKINCOLOR_GREY, SKINCOLOR_NICKEL, SKINCOLOR_BLACK, SKINCOLOR_JET}, -- 2: V_GREYMAP
	{SKINCOLOR_SEPIA, SKINCOLOR_BEIGE, SKINCOLOR_BROWN, SKINCOLOR_LEATHER, SKINCOLOR_RUST}, -- 3: V_BROWNMAP
	{SKINCOLOR_FAIRY, SKINCOLOR_SALMON, SKINCOLOR_PINK, SKINCOLOR_ROSE, SKINCOLOR_BRICK, SKINCOLOR_BUBBLEGUM, SKINCOLOR_LILAC}, -- 4: V_PINKMAP
	{SKINCOLOR_RUBY, SKINCOLOR_RASPBERRY, SKINCOLOR_CHERRY, SKINCOLOR_RED, SKINCOLOR_CRIMSON, SKINCOLOR_MAROON, SKINCOLOR_FLAME, SKINCOLOR_SCARLET, SKINCOLOR_KETCHUP}, -- 5: V_REDMAP
	{SKINCOLOR_DAWN, SKINCOLOR_SUNSET, SKINCOLOR_CREAMSICLE, SKINCOLOR_ORANGE, SKINCOLOR_PUMPKIN, SKINCOLOR_ROSEWOOD, SKINCOLOR_BURGUNDY, SKINCOLOR_TANGERINE}, -- 6: V_ORANGEMAP
	{SKINCOLOR_PEACH, SKINCOLOR_CARAMEL, SKINCOLOR_CREAM}, -- 7: V_PEACHMAP
	{SKINCOLOR_GOLD, SKINCOLOR_ROYAL, SKINCOLOR_BRONZE, SKINCOLOR_COPPER}, -- 8: V_GOLDMAP
	{SKINCOLOR_POPCORN, SKINCOLOR_YELLOW, SKINCOLOR_MUSTARD, SKINCOLOR_OLIVE}, -- 9: V_YELLOWMAP
	{SKINCOLOR_VOMIT, SKINCOLOR_GARDEN, SKINCOLOR_TEA, SKINCOLOR_PISTACHIO}, -- 10: V_TEAMAP
	{SKINCOLOR_LIME, SKINCOLOR_HANDHELD, SKINCOLOR_MOSS, SKINCOLOR_CAMOUFLAGE, SKINCOLOR_ROBOHOOD, SKINCOLOR_MINT, SKINCOLOR_GREEN, SKINCOLOR_PINETREE, SKINCOLOR_EMERALD, SKINCOLOR_SWAMP, SKINCOLOR_DREAM, SKINCOLOR_PLAGUE, SKINCOLOR_ALGAE}, -- 11: V_GREENMAP
	{SKINCOLOR_CARIBBEAN, SKINCOLOR_AQUA, SKINCOLOR_TEAL, SKINCOLOR_CYAN, SKINCOLOR_JAWZ, SKINCOLOR_CERULEAN, SKINCOLOR_NAVY, SKINCOLOR_SAPPHIRE}, -- 12: V_SKYMAP
	{SKINCOLOR_PLATINUM, SKINCOLOR_STEEL}, -- 13: V_STEELMAP
	{SKINCOLOR_PERIWINKLE, SKINCOLOR_BLUE, SKINCOLOR_BLUEBERRY, SKINCOLOR_NOVA}, -- 14: V_BLUEMAP
	{SKINCOLOR_ULTRAVIOLET, SKINCOLOR_PURPLE, SKINCOLOR_FUCHSIA}, -- 15: V_PURPLEMAP
	{SKINCOLOR_PASTEL, SKINCOLOR_MOONSLAM, SKINCOLOR_DUSK, SKINCOLOR_TOXIC, SKINCOLOR_MAUVE, SKINCOLOR_LAVENDER, SKINCOLOR_BYZANTIUM, SKINCOLOR_POMEGRANATE} -- 16: V_LAVENDERMAP
	}
	
	local maps = {"\x80", "\x86", "\x8e", "\x8d", "\x85", "\x87", "\x8f", "\x8A", "\x82", "\x8b", "\x83", "\x88", "\x8c", "\x84", "\x81", "\x89"}
	if (vflag)
		maps = {0, V_GRAYMAP, V_BROWNMAP, V_PINKMAP, V_REDMAP, V_ORANGEMAP, V_PEACHMAP, V_GOLDMAP, V_YELLOWMAP, V_TEAMAP, V_GREENMAP, V_SKYMAP, V_STEELMAP, V_BLUEMAP, V_PURPLEMAP, V_LAVENDERMAP}
	end
	
	for i = 1, #colour_sets
		for j = 1, #colour_sets[i]
			local colour = colour_sets[i][j]
			
			if (colour == c)
				return maps[i]
			end
		end
	end
	
	return maps[1]
end

tsrb2kr.AssignTeam = function(p, team)
	if not (p and p.mo) or p.spectator then return end
	if G_BattleGametype() then return end
	
	server.tsr_server.playersperteam = $ or 3
	-- quick special cases:
	if (tsrb2kr.GetPlayerCount() == 2)
		server.tsr_server.playersperteam = 1	-- 1 player / team
	elseif (tsrb2kr.GetPlayerCount() == 3)
		server.tsr_server.playersperteam = 2	-- 2 player / team (2v1)
	end
	
	-- team colours
	local ColorToMap, ColorToString, ReturnTeamColor = tsrb2kr.ColorToMap, tsrb2kr.ColorToString, tsrb2kr.ReturnTeamColor
	local c = {
		{ColorToMap(ReturnTeamColor(1)), ColorToString(ReturnTeamColor(1))},
		{ColorToMap(ReturnTeamColor(2)), ColorToString(ReturnTeamColor(2))}, 
		{ColorToMap(ReturnTeamColor(3)), ColorToString(ReturnTeamColor(3))}, 
		{ColorToMap(ReturnTeamColor(4)), ColorToString(ReturnTeamColor(4))}, 
		{ColorToMap(ReturnTeamColor(5)), ColorToString(ReturnTeamColor(5))}
	}
	
	if (team)	-- assign the team directly, for tourney mode?
		-- join message
		if (server.tsr_server.tourneyround)
			local teamname = server.tsr_tourneynames[team]
			print(p.name.." joined "..(c[team][1])..teamname.."\x80"..".")
		else
			print(p.name.." joined the "..(c[team][1])..(c[team][2]).." Team".."\x80"..".")
		end
		
		p.tsr.team = team
		table.insert(server.tsr_server.teams[team], p)
		return
	else	-- get what team we'll join
		for i = 1, 5
			if (tsrb2kr.GetPlayerCount(true) == 4) and (#server.tsr_server.teams[i] == 0)
				/*
					very special case, if we have 4 players left, instead of putting 3 in a team and 1 alone,
					put 2 and 2 in a team
				*/
				server.tsr_server.playersperteam = $-1
			end
			
			if (#server.tsr_server.teams[i] >= server.tsr_server.playersperteam) then continue end	-- nope
			-- join the team!
			p.tsr.team = i
			print(p.name.." joined the "..(c[i][1])..(c[i][2]).." Team".."\x80"..".")
			table.insert(server.tsr_server.teams[i], p)
			if not (tsrb2kr.GetPlayerCount(true)) then server.tsr_server.playersperteam = 3 end
			
			-- visual/sound stuff
			p.tsr.displayteam = 3*TICRATE
			if (leveltime != 105) then S_StartSound(nil, sfx_kc48, p) end
			return
		end
	end
	
	CONS_Printf(consoleplayer, "This mod is designed for 15 players, lower the player count!")
end

tsrb2kr.ReturnTeam = function(p)
	for i = 1, 5
		if not (#server.tsr_server.teams[i]) then continue end
		
		for j = 1, #server.tsr_server.teams[i]
			if (p == server.tsr_server.teams[i][j]) then return i end -- we found what team we're on
		end
	end
	
	return 0 -- we couldnt find them
end

tsrb2kr.ReturnPoints = function(p)
	local positionPoints = {18, 15, 13, 12, 11, 10, 9, 8, 7, 6, 5, 4, 3, 2, 1, 1}
	
	local points = positionPoints[p.kartstuff[k_position]] or 1	-- failsafe this time
	local team = server.tsr_server.teams[p.tsr.team]
	
	-- take in account solo and duo teams
	if (#team == 1)	-- solo team
		-- 2.5 boost
		points = $*5/2
	elseif (#team == 2)	-- duo team
		-- 1.4 boost per player
		points = $ + points*4/10
	end
	if (p.pflags & PF_TIMEOVER) then points = $/2 end	-- we timed over, halve our points!

	return points
end

tsrb2kr.ReturnTeamPoints = function(team)
	if not (#server.tsr_server.teams[team]) then return 0 end -- team doesnt have any players, return 0
	
	-- tally up player points on a team
	local tally = 0
	for i = 1, #server.tsr_server.teams[team]
		local p = server.tsr_server.teams[team][i]
		if not (p and p.valid) then continue end
		
		tally = $+(tsrb2kr.ReturnPoints(p))
	end
	
	return tally
end

tsrb2kr.ReturnFinishTeamScore = function(t)
	local tbl = server.tsr_server.finishteamscore[t]
	if not tbl or not #tbl return 0 end	-- nothing to return

	local sum = 0
	for i = 1, #tbl do
		sum = $ + tbl[i].score
	end
	return sum
end

tsrb2kr.FlipFromObject = function(mo, master)
	mo.eflags = (mo.eflags & ~MFE_VERTICALFLIP)|(master.eflags & MFE_VERTICALFLIP)
	mo.flags2 = (mo.flags2 & ~MF2_OBJECTFLIP)|(master.flags2 & MF2_OBJECTFLIP)

	if (mo.eflags & MFE_VERTICALFLIP)
		mo.z = $+ master.height - FixedMul(master.scale, mo.height)
	end
end

local mkfnt = {}
for i = 1, 255
    local s = string.format("MKFNT%03d", i)
    mkfnt[i] = s
end
tsrb2kr.DrawMKText = function(v, str, x, y, flags, align)
    if str == "" then str = "-" end
    if str == nil then str = "nil" end
    str = tostring(str)
    str = str:upper()
	
    local dt = {}
    local offset = 0
    for i = 1,#str do
        local by = string.byte(str:sub(i,i))
        if mkfnt[by] ~= nil
        and v.patchExists(mkfnt[by])    -- if patch exists, ready it
            local pp = v.cachePatch(mkfnt[by])
            dt[#dt+1] = {pp, offset}
            offset = $ + pp.width
        else
            offset = $ + 16
        end
    end

    local eo = 0
    if align == "center" then
        eo = offset/2
    end
    if align == "right" then
        eo = offset
    end

    for i = 1,#dt do
        local ix = dt[i]
        v.draw(x+ix[2]-eo, y, ix[1], flags)
    end
end

tsrb2kr.ReturnSplitFlags = function(f, displaynum)
	if not (splitscreen) return f end

	-- exhibit 1: 2p
	if (splitscreen == 1)
		if not (displaynum) -- p1
			return f & ~(V_SNAPTOBOTTOM)
		else	-- p2
			return (f|V_SPLITSCREEN) & ~(V_SNAPTOTOP)
		end
	else
		-- jesus fuck this sucks dicks
		if not (displaynum)	-- p1
			return f & ~(V_SNAPTOBOTTOM|V_SNAPTORIGHT)
		elseif (displaynum == 1)	-- p2
			return (f|V_HORZSCREEN) & ~(V_SNAPTOBOTTOM|V_SNAPTOLEFT)
		elseif (displaynum == 2)	-- p3
			return (f|V_SPLITSCREEN) & ~(V_SNAPTOTOP|V_SNAPTORIGHT)
		elseif (displaynum == 3)	-- p4
			return (f|V_SPLITSCREEN|V_HORZSCREEN) & ~(V_SNAPTOTOP|V_SNAPTOLEFT)
		end
	end
	
	return f	-- shouldn't happen but don't return nil either way lol
end

tsrb2kr.SmartSetColor = function(p, cr, c, ninvinc, ngrowth, nshrink, neggman, ndropdash)
	if not (p and p.mo) or p.spectator then return end
	local flashtime = 4<<(p.kartstuff[k_eggmanexplode]/TICRATE)

	if (p.kartstuff[k_invincibilitytimer] and not ninvinc) -- invincibility is an obvious no-no
	or (((p.kartstuff[k_growshrinktimer] ~= 0 and p.kartstuff[k_growshrinktimer] < 0) and p.kartstuff[k_growshrinktimer] % 5 == 0) and not ngrowth) -- player is flashing due to growth
	or (((p.kartstuff[k_growshrinktimer] ~= 0 and p.kartstuff[k_growshrinktimer] > 0) and p.kartstuff[k_growshrinktimer] % 5 == 0) and not nshrink) -- player is flashing due to shrink
	or ((p.kartstuff[k_eggmanexplode] and not ((p.kartstuff[k_eggmanexplode]+1) % (flashtime/2) != 0)) and not neggman) -- player is flashing due to eggman
	or ((p.kartstuff[k_dropdash] >= TICRATE/4 and p.kartstuff[k_dropdash] & 1) and not ndropdash) -- player is flashing due to dropdash
		return
	end
	
	p.mo.colorized, p.mo.color = cr, c
end

tsrb2kr.IsDisplayPlayer = function(p)
	for dp, n in displayplayers.iterate
		if (p != dp) then continue end	-- that's not us
		return n
	end
	
	-- if we're here, we're not a displayplayer
	return false
end

tsrb2kr.PlayerNeedsSkimboost = function(p)
	local mo = p.mo
	
	if not ((mo and mo.valid) and mo.health) then return false end	-- needs to exist
	if (p.exiting) then return false end	-- we dont need a skimboost after finishing
	if (mo.tsr_skimboost) then return false end	-- already skimboosted
	if (mo.tsr_skimboostcd and not ((p.kartstuff[k_spinouttimer] or p.kartstuff[k_wipeoutslow]) or p.kartstuff[k_squishedtimer])) then return false end	-- cant be on skimboost cooldown! (unless hurt)
	
	-- create some conditions, easier checking
	local hurt = (p.kartstuff[k_spinouttimer] or p.kartstuff[k_wipeoutslow]) or p.kartstuff[k_squishedtimer]
	local drifting = p.kartstuff[k_drift] and not p.kartstuff[k_driftend]
	
	-- checks
	if ((hurt) or (((drifting) and p.kartstuff[k_getsparks] == 0) or (not (drifting) and R_PointToDist2(0, 0, mo.momx, mo.momy) < K_GetKartSpeed(p)/2)))	-- they're hurt, or slow
	and (P_IsObjectOnGround(mo) or (hurt))	-- and they're on the ground, or hurt
	and not (mo.tsr_skimboostcd and not (hurt))	-- they arent on skimboost cooldown, unless hurt
		-- needs skimboost
		return true
	end
	
	-- doesnt need skimboost
	return false
end

tsrb2kr.IsRival = function(p1, p2)
	if not (p1 and p1.valid) then return end
	if not (p2 and p2.valid) then return end
	if (leveltime < TICRATE*5 + 6*TICRATE + (3*TICRATE/4)) then return end
	
	if not (p1.tsr) then return end
	if not (p2.tsr) then return end
	
	if not (p1.tsr.team) then return end
	if not (p2.tsr.team) then return end
	
	local sortedteams = server.tsr_server.sortedteams
	if not (sortedteams) then return end
	if not (#sortedteams) then return end

	-- get both players teams
	local p1team, p2team
	for i = 1, #sortedteams
		local team = sortedteams[i]	-- current team
		-- check if this team is p1's team
		if (sortedteams[i][1] == p1.tsr.team)
			p1team = team
        end
		-- ditto, for p2
		if (sortedteams[i][1] == p2.tsr.team)
			p2team = team
        end
	end
	-- we need both teams to check between them!
	if not (p1team and p2team) then return end	-- they need to exist
	if (p1team == p2team) then return end	-- teammates cant be rivals

	-- check if p2's team position is right above p1's, they'd be our rival!
	if (p2team[3] == (p1team[3]-1))
		return true
	end

	return false
end

tsrb2kr.FillUltimate = function(p, amount, text, textcolours, sound, nooverwrite)
    -- fill ult:
    if not (p.tsr.team) then return end    -- can't do that.
    local team = server.tsr_server.teams[p.tsr.team]
    local teamlen = #team
	
    -- your position relative to the max possible position affects ult charge,
    -- so first placers don't build up much. (unless you're a solo team)
	if (teamlen != 1)
		local maxpos = tsrb2kr.GetPlayerCount()
		amount = max(0, $ - max(0, ((maxpos/2) - p.kartstuff[k_position]*3/2)*2))
	end
	
	-- the # of players in the team affects how much ultimate you get
	amount = $ + ((3-teamlen)*amount/2)

    server.tsr_server.ultimates[p.tsr.team] = $ + amount
	if (sound) then S_StartSound(nil, sound, p) end

    if (text)
    and not (p.tsr.teammsg_nooverwrite)
        p.tsr.teammsg = text
        p.tsr.teammsg_time = TICRATE*2
		p.tsr.teammsg_colours = textcolours
        p.tsr.teammsg_nooverwrite = nooverwrite    -- don't overwrite this!
    end
end

-- yes good idea lets push uint32 to int32, itll be ok they said
-- NO IT'S NOT FUCKING OK YOU ABSOLUTE DUMBASS
tsrb2kr.AngToInt = function(a)
    if not a return 0 end
    a = $/ANG1
    if a < 0
        a = $+360
    end
    return a
end

tsrb2kr.StringToMapnum = function(s)
	-- check if it's not an extended map number
	local n = tonumber(s)
	if (n and (n >= 1 and n <= 99))
		return n
	end
	
	-- if we're here, must be an extended map number
	local chars1 = {"A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z"}
	local chars2 = {"0", "1", "2", "3", "4", "5", "6", "7", "8", "9"}
	for i = 1, #chars1
		table.insert(chars2, chars1[i])
	end
	
	-- now let's check all of the extended map numbers
	local mapnum = 100
	for i = 1, #chars1
		for j = 1, #chars2
			local extended_mapnum = chars1[i] + chars2[j]
			
			if (s == extended_mapnum)	-- we got a match?
				return mapnum
			end
			mapnum = $+1
		end
	end
	
	return nil
end