-- all the freeslots and thinkers for said freeslots

-- ranking sounds
freeslot("sfx_rnkp", "sfx_rnk1st")

-- RIVAL indicator
freeslot("MT_TSR_RIVAL", "SPR_RIVL")
for i = 1, 7 do freeslot("S_TSR_RIVAL"..i) end
local rivalTics = {5, 1, 3, 1, 3, 1, 3}
for i = 1, 7
	states[S_TSR_RIVAL1+(i-1)] = {SPR_RIVL, FF_FULLBRIGHT|0+(i-1), rivalTics[i], nil, 0, 0, i<7 and S_TSR_RIVAL1+i or S_TSR_RIVAL1}
end
mobjinfo[MT_TSR_RIVAL] = {
	spawnstate = S_TSR_RIVAL1,
	deathstate = S_NULL,
	radius = 36*FRACUNIT,
	height = 37*FRACUNIT,
	dispoffset = -2,
	flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_SCENERY|MF_DONTENCOREMAP
}
addHook("MobjThinker", function(rvl)
	if (rvl and rvl.valid)
		-- now for remove situations
		if not ((rvl.target and rvl.target.valid) and rvl.target.player) then P_RemoveMobj(rvl) return end -- they dont have a target, or it's not a player
		if not (rvl.target.player.health) then P_RemoveMobj(rvl) return end -- target is dead

		local s = rvl.target.scale*11/10 -- base scale

		-- don't draw if the target isnt drawn
		if (rvl.target.flags2 & MF2_DONTDRAW)
			rvl.flags2 = $|MF2_DONTDRAW
		else
			rvl.flags2 = $ & ~MF2_DONTDRAW
		end

		-- set scale
		if not (splitscreen)
			if ((displayplayers[0] and displayplayers[0].valid) and (displayplayers[0].mo and displayplayers[0].mo.valid))
				s = rvl.target.scale + FixedMul(FixedDiv(abs(P_AproxDistance(displayplayers[0].mo.x - rvl.target.x, displayplayers[0].mo.y - rvl.target.y)), 1280<<FRACBITS), rvl.target.scale)
				if (s > 6*rvl.target.scale)
					s = 6*rvl.target.scale
				end
			end
		end
		rvl.destscale = s

		-- hide if this guy ain't our rival (with splitscreen support, BLESS 1.2)
		local drawFlags = {MFE_DRAWONLYFORP1, MFE_DRAWONLYFORP2, MFE_DRAWONLYFORP3, MFE_DRAWONLYFORP4}
		for i = 0, (splitscreen) -- go through displayplayers
			if not (displayplayers[i]) then break end
			if (rvl.target.player == displayplayers[i]) then rvl.eflags = $ & ~(drawFlags[i+1]) continue end -- dont show yourself
					
			if (tsrb2kr.IsRival(displayplayers[i], rvl.target.player))
			and not (rvl.target.player.exiting)
				rvl.eflags = $|drawFlags[i+1]
			else
				rvl.eflags = $ & ~(drawFlags[i+1])
			end
		end
		-- somehow this isnt supposed to be displayed at ALL for any displayplayers, so dont draw it
		if not (rvl.eflags & (MFE_DRAWONLYFORP1|MFE_DRAWONLYFORP2|MFE_DRAWONLYFORP3|MFE_DRAWONLYFORP4))
			rvl.flags2 = $|MF2_DONTDRAW
		end

		-- set position (flip support too)
		if (rvl.target.eflags & MFE_VERTICALFLIP)
			P_TeleportMove(rvl, rvl.target.x, rvl.target.y, rvl.target.z - P_GetPlayerHeight(rvl.target.player) - (16*rvl.target.scale) - (32*s))
			rvl.eflags = $|MFE_VERTICALFLIP
		else
			P_TeleportMove(rvl, rvl.target.x, rvl.target.y, rvl.target.z + P_GetPlayerHeight(rvl.target.player) + (16*rvl.target.scale) + (32*s))
			rvl.eflags = $ & ~MFE_VERTICALFLIP
		end
	end
end, MT_TSR_RIVAL)

-- skimboost related
-- indicator
freeslot("S_TSR_SKIMBINDICATOR", "MT_TSR_SKIMBINDICATOR", "SPR_SKMI", "SPR_SKMF")
states[S_TSR_SKIMBINDICATOR] = {SPR_SKMI, A|FF_ANIMATE, -1, nil, 1, 5, S_TSR_SKIMBINDICATOR}
mobjinfo[MT_TSR_SKIMBINDICATOR] = {
	spawnstate = S_TSR_SKIMBINDICATOR,
	deathstate = S_NULL,
	spawnhealth = 1000,
	radius = 36*FRACUNIT,
	height = 37*FRACUNIT,
	dispoffset = -2,
	flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_DONTENCOREMAP
}
addHook("MobjThinker", function(skimi)
	if (skimi and skimi.valid)
		-- now for remove situations
		if not (skimi.target and skimi.target.player) then P_RemoveMobj(skimi) return end -- they dont have a target, or it's not a player
		if not (skimi.target.player.health) then P_RemoveMobj(skimi) return end -- target is dead
		-- remove if they dont need a skimboost
		if not (tsrb2kr.PlayerNeedsSkimboost(skimi.target.player))
			P_RemoveMobj(skimi)
			return
		end
		if not (skimi.target.player.tsr.team) then P_RemoveMobj(skimi) return end	-- they dont have a team!
		
		-- set color
		skimi.color = tsrb2kr.ReturnTeamColor(skimi.target.player.tsr.team)
		
		-- set scale
		local s = 3*skimi.target.scale/2 -- base scale
		if not (splitscreen)
			if (displayplayers[0] and displayplayers[0].valid) and (displayplayers[0].mo and displayplayers[0].mo.valid)
				s = min(16*skimi.target.scale, skimi.target.scale + FixedMul(FixedDiv(abs(P_AproxDistance(displayplayers[0].mo.x - skimi.target.x, displayplayers[0].mo.y - skimi.target.y)), 1280<<FRACBITS), skimi.target.scale))
			end
		end
		skimi.destscale = s
		
		skimi.flags2 = $ & ~MF2_DONTDRAW
		-- show on teammates and hide on self, with splitscreen support (bless 1.2 again)
		local drawFlags = {MFE_DRAWONLYFORP1, MFE_DRAWONLYFORP2, MFE_DRAWONLYFORP3, MFE_DRAWONLYFORP4}
		for i = 0, (splitscreen) -- go through displayplayers
			if not displayplayers[i] then break end
			if (skimi.target.player == displayplayers[i]) then skimi.eflags = $ & ~(drawFlags[i+1]) continue end -- dont show yourself
					
			if (tsrb2kr.ReturnTeam(displayplayers[i]) == tsrb2kr.ReturnTeam(skimi.target.player))
				skimi.eflags = $|drawFlags[i+1]
			else
				skimi.eflags = $ & ~(drawFlags[i+1])
			end
		end
		-- somehow this isnt supposed to be displayed at ALL for any displayplayers, so dont draw it
		if not (skimi.eflags & (MFE_DRAWONLYFORP1|MFE_DRAWONLYFORP2|MFE_DRAWONLYFORP3|MFE_DRAWONLYFORP4))
			skimi.flags2 = $|MF2_DONTDRAW
		end

		-- set position (flip support too)
		local shiftNum = ((skimi.target.player.kartstuff[k_spinouttimer] or skimi.target.player.kartstuff[k_wipeoutslow]) or skimi.target.player.kartstuff[k_squishedtimer]) and 4 or 2
		local xpos, ypos, zpos = skimi.target.x+P_RandomRange(-shiftNum, shiftNum)*skimi.target.scale, skimi.target.y+P_RandomRange(-shiftNum, shiftNum)*skimi.target.scale, skimi.target.z+P_RandomRange(-shiftNum, shiftNum)*skimi.target.scale
		-- flashing
		skimi.sprite = (leveltime%4 <= 2) and SPR_SKMF or SPR_SKMI
		
		if skimi.target.eflags & MFE_VERTICALFLIP
			P_TeleportMove(skimi, xpos, ypos, zpos - (P_GetPlayerHeight(skimi.target.player)/2) - (-21*skimi.target.scale) - (64*s))
			skimi.eflags = $|MFE_VERTICALFLIP
		else
			P_TeleportMove(skimi, xpos, ypos, zpos + (P_GetPlayerHeight(skimi.target.player)/2) + (-21*skimi.target.scale) + (64*s))
			skimi.eflags = $ & ~MFE_VERTICALFLIP
		end
	end
end, MT_TSR_SKIMBINDICATOR)

-- object
freeslot("MT_TSR_SKIMB", "SPR_SKMB")
mobjinfo[MT_TSR_SKIMB] = {
	spawnstate = S_THOK,	-- must be modified on spawn, our script takes care of it (...)
	deathstate = S_NULL,
	spawnhealth = 1000,
	radius = 128*FRACUNIT,
	height = 256*FRACUNIT,
	dispoffset = 2,
	flags = MF_NOGRAVITY|MF_DONTENCOREMAP|MF_NOCLIPHEIGHT
}
addHook("MobjThinker", function(mo)
	if not mo or not mo.valid return end
	if not mo.target or not mo.target.valid
		-- uh yeah, FOH
		P_RemoveMobj(mo)
		return
	end
	
	mo.flags2 = $ & ~MF2_DONTDRAW
	-- show on teammates and hide on self, with splitscreen support (bless 1.2 yet again)
	local drawFlags = {MFE_DRAWONLYFORP1, MFE_DRAWONLYFORP2, MFE_DRAWONLYFORP3, MFE_DRAWONLYFORP4}
	for i = 0, (splitscreen) -- go through displayplayers
		if not displayplayers[i] then break end
		
		if (tsrb2kr.ReturnTeam(displayplayers[i]) == tsrb2kr.ReturnTeam(mo.target.player))
			mo.eflags = $|drawFlags[i+1]
		else
			mo.eflags = $ & ~(drawFlags[i+1])
		end
	end
	-- somehow this isnt supposed to be displayed at ALL for any displayplayers, so dont draw it
	if not (mo.eflags & (MFE_DRAWONLYFORP1|MFE_DRAWONLYFORP2|MFE_DRAWONLYFORP3|MFE_DRAWONLYFORP4))
		mo.flags2 = $|MF2_DONTDRAW
	end
	
	mo.color = tsrb2kr.ReturnTeamColor(mo.target.player.tsr.team)
	mo.scalespeed = mapobjectscale/8
	mo.destscale = 1

	P_TeleportMove(mo, mo.target.x, mo.target.y, mo.target.z)
	mo.angle = mo.target.angle + ANG1*90

	if mo.scale < FRACUNIT/20
		P_RemoveMobj(mo)
		return
	end
end, MT_TSR_SKIMB)

-- slingshot level indicators
freeslot("MT_TSR_SLINGSHOTLEVEL", "SPR_SLNS")
for i = 1,3
	freeslot("S_TSR_SLINGSHOTLEVEL"..i)
end
for i = 1, 3
	local tr = {TR_TRANS20, TR_TRANS30, TR_TRANS60}
	states[S_TSR_SLINGSHOTLEVEL1 + (i-1)] = {SPR_SLNS, (i-1)|tr[i]|FF_PAPERSPRITE|FF_FULLBRIGHT, 2, nil, 0, 0, i < 3 and (S_TSR_SLINGSHOTLEVEL1 +i) or S_NULL}
end
mobjinfo[MT_TSR_SLINGSHOTLEVEL] = {
	spawnstate = S_TSR_SLINGSHOTLEVEL1,	-- must be modified on spawn, our script takes care of it (...)
	deathstate = S_NULL,
	spawnhealth = 1000,
	radius = 65*FRACUNIT,
	height = 132*FRACUNIT,
	dispoffset = 2,
	flags = MF_NOGRAVITY|MF_DONTENCOREMAP|MF_NOCLIPHEIGHT
}
addHook("MobjThinker", function(mo)
	if not mo or not mo.valid return end
	if not mo.target or not mo.target.valid
		-- uh yeah, FOH
		P_RemoveMobj(mo)
		return
	end
	
	if mo.nomomentum return end

	P_TeleportMove(mo, mo.target.x, mo.target.y, mo.target.z)
	mo.angle = mo.target.angle + ANG1*90
end, MT_TSR_SLINGSHOTLEVEL)

-- boost "trail"
freeslot("MT_TSR_BOOST", "S_TSRBOOST1", "S_TSRBOOST2", "SPR_TSRT")
mobjinfo[MT_TSR_BOOST] = {
	spawnstate = S_THOK,	-- must be modified on spawn, our script takes care of it (...)
	deathstate = S_NULL,
	spawnhealth = 1000,
	radius = 96*FRACUNIT,
	height = 192*FRACUNIT,
	dispoffset = -2,
	flags = MF_NOGRAVITY|MF_DONTENCOREMAP|MF_NOCLIPHEIGHT
}

-- Team Marker
freeslot("S_TSR_MARKER", "MT_TSR_MARKER")
states[S_TSR_MARKER] = {SPR_ARRO, A, -1, nil, 0, 0, S_TSR_MARKER}
mobjinfo[MT_TSR_MARKER] = {
	spawnstate = S_TSR_MARKER,
	deathstate = S_NULL,
	spawnhealth = 1000,
	radius = 36*FRACUNIT,
	height = 37*FRACUNIT,
	dispoffset = -2,
	flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_DONTENCOREMAP
}
addHook("MobjThinker", function(marker)
	if (marker and marker.valid)
		-- now for remove situations
		if not (marker.target and marker.target.player) then P_RemoveMobj(marker) return end -- they dont have a target, or it's not a player
		if not (marker.target.player.health) then P_RemoveMobj(marker) return end -- target is dead
		if not (marker.target.player.tsr.team) then P_RemoveMobj(marker) return end	-- they dont have a team!
		
		marker.color = tsrb2kr.ReturnTeamColor(marker.target.player.tsr.team)

		-- set scale
		local s = 3*marker.target.scale/2 -- base scale
		if not (splitscreen)
			if (displayplayers[0] and displayplayers[0].valid) and (displayplayers[0].mo and displayplayers[0].mo.valid)
				s = min(16*marker.target.scale, marker.target.scale + FixedMul(FixedDiv(abs(P_AproxDistance(displayplayers[0].mo.x - marker.target.x, displayplayers[0].mo.y - marker.target.y)), 1280<<FRACBITS), marker.target.scale))
			end
		end
		marker.destscale = s
		
		marker.flags2 = $ & ~MF2_DONTDRAW
		-- show on teammates and hide on self, with splitscreen support (gonna keep blessing 1.2)
		local drawFlags = {MFE_DRAWONLYFORP1, MFE_DRAWONLYFORP2, MFE_DRAWONLYFORP3, MFE_DRAWONLYFORP4}
		for i = 0, (splitscreen) -- go through displayplayers
			if not displayplayers[i] then break end
			local p = displayplayers[i]	-- laziness
			if not (p and p.valid) then continue end
				
			if (marker.target.player == p) then marker.eflags = $ & ~(drawFlags[i+1]) continue end -- dont show yourself
					
			if (tsrb2kr.ReturnTeam(p) == tsrb2kr.ReturnTeam(marker.target.player))
			and not (p.tsr.displayteam and (p.tsr.displayteam >= 75 and p.tsr.displayteam%10 >= 5))
				marker.eflags = $|drawFlags[i+1]
			else
				marker.eflags = $ & ~(drawFlags[i+1])
			end
		end
		-- somehow this isnt supposed to be displayed at ALL for any displayplayers, so dont draw it
		if not (marker.eflags & (MFE_DRAWONLYFORP1|MFE_DRAWONLYFORP2|MFE_DRAWONLYFORP3|MFE_DRAWONLYFORP4))
			marker.flags2 = $|MF2_DONTDRAW
		end

		-- set position (flip support too)
		if marker.target.eflags & MFE_VERTICALFLIP
			P_TeleportMove(marker, marker.target.x, marker.target.y, marker.target.z - (P_GetPlayerHeight(marker.target.player)/2) - (16*marker.target.scale) - (64*s))
			marker.eflags = $|MFE_VERTICALFLIP
		else
			P_TeleportMove(marker, marker.target.x, marker.target.y, marker.target.z + (P_GetPlayerHeight(marker.target.player)/2) + (16*marker.target.scale) + (64*s))
			marker.eflags = $ & ~MFE_VERTICALFLIP
		end
	end
end, MT_TSR_MARKER)

-- team item highlight marker
freeslot("S_TSR_HIGHLIGHTITEM", "MT_TSR_HIGHLIGHTITEM", "SPR_TMHI")
states[S_TSR_HIGHLIGHTITEM] = {SPR_TMHI, A|FF_ANIMATE, -1, nil, 1, 4, S_TSR_HIGHLIGHTITEM}
mobjinfo[MT_TSR_HIGHLIGHTITEM] = {
	spawnstate = S_TSR_HIGHLIGHTITEM,
	deathstate = S_NULL,
	spawnhealth = 1000,
	radius = 36*FRACUNIT,
	height = 37*FRACUNIT,
	dispoffset = -2,
	flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_DONTENCOREMAP
}
addHook("MobjThinker", function(marker)
	if (marker and marker.valid)
		-- now for remove situations
		if not (marker.target and marker.target.valid) then P_RemoveMobj(marker) return end -- they dont have a target
		if not (marker.target.health) then P_RemoveMobj(marker) return end -- target is dead
		if not (marker.target.target and marker.target.target.valid) then P_RemoveMobj(marker) return end
		if not (marker.target.target.player.tsr.team) then P_RemoveMobj(marker) return end	-- no team
		
		marker.color = tsrb2kr.ReturnTeamColor(marker.target.target.player.tsr.team)
		
		local s = 3*marker.target.scale/2 -- base scale
		marker.frame = $|FF_FULLBRIGHT

		-- set scale
		if not (splitscreen)
			if (displayplayers[0] and displayplayers[0].valid) and (displayplayers[0].mo and displayplayers[0].mo.valid)
				s = min(16*marker.target.scale, marker.target.scale + FixedMul(FixedDiv(abs(P_AproxDistance(displayplayers[0].mo.x - marker.target.x, displayplayers[0].mo.y - marker.target.y)), 1280<<FRACBITS), marker.target.scale))
			end
		end
		marker.destscale = s

		marker.flags2 = $ & ~MF2_DONTDRAW
		-- show on teammates and hide on self, with splitscreen support (you already know what I'm gonna bless, 1.2)
		local drawFlags = {MFE_DRAWONLYFORP1, MFE_DRAWONLYFORP2, MFE_DRAWONLYFORP3, MFE_DRAWONLYFORP4}
		for i = 0, (splitscreen) -- go through displayplayers
			if not displayplayers[i] then break end
			if (marker.target.target.player == displayplayers[i]) then marker.eflags = $ & ~(drawFlags[i+1]) continue end -- dont show yourself
					
			if (tsrb2kr.ReturnTeam(displayplayers[i]) == tsrb2kr.ReturnTeam(marker.target.target.player))
			and not CV_FindVar("friendlyfire").value	-- friendlyfire is on, dont mislead
				marker.eflags = $|drawFlags[i+1]
			else
				marker.eflags = $ & ~(drawFlags[i+1])
			end
		end
		-- somehow this isnt supposed to be displayed at ALL for any displayplayers, so dont draw it
		if not (marker.eflags & (MFE_DRAWONLYFORP1|MFE_DRAWONLYFORP2|MFE_DRAWONLYFORP3|MFE_DRAWONLYFORP4))
			marker.flags2 = $|MF2_DONTDRAW
		end

		-- set position (flip support too)
		if marker.target.eflags & MFE_VERTICALFLIP
			P_TeleportMove(marker, marker.target.x, marker.target.y, marker.target.z - (2*marker.target.scale) - (16*s))
			marker.eflags = $|MFE_VERTICALFLIP
		else
			P_TeleportMove(marker, marker.target.x, marker.target.y, marker.target.z + marker.target.height + (2*marker.target.scale) + (16*s))
			marker.eflags = $ & ~MFE_VERTICALFLIP
		end
	end
end, MT_TSR_HIGHLIGHTITEM)

-- team coloured items
freeslot("SPR_TBNA", "SPR_TJWZ", "SPR_THOG", "SPR_TSPB") 
-- spb needs special treatment
local frameList = {0, 1, 0, 2, 0, 3, 0, 4, 0, 5, 0, 6, 0, 7, 0, 8, 0, 8, 0, 8}
for i = 1, 20
	freeslot("S_TSRSPB"..i)
	states[S_TSRSPB1+(i-1)] = {SPR_TSPB, frameList[i], 1, A_SPBChase, 0, 0, S_TSRSPB1+(i<20 and i or 0)}
end

-- ultimate timing sparks
freeslot("S_TSR_ULTIMATESPARK", "MT_TSR_ULTIMATESPARK", "SPR_ULTS")
states[S_TSR_ULTIMATESPARK] = {SPR_ULTS, FF_FULLBRIGHT|A|FF_ANIMATE, -1, nil, 1, 1, S_TSR_ULTIMATESPARK}
mobjinfo[MT_TSR_ULTIMATESPARK] = {
	spawnstate = S_TSR_ULTIMATESPARK,
	deathstate = S_NULL,
	radius = 2*FRACUNIT,
	width = 2*FRACUNIT,
	flags = MF_NOBLOCKMAP,
}
addHook("MobjThinker", function(spark)
	if P_IsObjectOnGround(spark) then P_RemoveMobj(spark) end
end, MT_TSR_ULTIMATESPARK)